/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Amortizacao;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class AmortizacaoDAO  {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public AmortizacaoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param esp
     * @throws JogosDAOException
     */
    public void salvar(Amortizacao esp) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (esp == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into amortizacao (esp_em_id, esp_ep_id, esp_tcm_id, esp_vlEmprestimo, esp_vlAmortizacao,"
                    + "esp_vlJuros, esp_vlSaldoDevedor) "
                    + "values (?,?,?,?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, esp.getEsp_em_id());
            ps.setInt(2, esp.getEsp_ep_id());
            ps.setInt(3, esp.getEsp_tcm_id());
            ps.setDouble(4, esp.getEsp_vlEmprestimo());
            ps.setDouble(5, esp.getEsp_vlAmortizacao());
            ps.setDouble(6, esp.getEsp_vlJuros());
            ps.setDouble(7, esp.getEsp_vlSaldoDevedor());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param esp
     * @throws JogosDAOException
     */
    public void excluir(Amortizacao esp) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (esp == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from amortizacao where esp_id=?");
            ps.setInt(1, esp.getEsp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param esp
     * @throws JogosDAOException
     */
    public void atualizar(Amortizacao esp) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (esp == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update amortizacao set "
                    + "esp_vlEmprestimo= ?, "
                    + "esp_vlAmortizacao= ?, "
                    + "esp_vlJuros= ?, "
                    + "esp_tcm_id= ?, "
                    + "esp_vlSaldoDevedor= ? "
                    + "where esp_id=?";
            System.out.print(SQL);
            conne = this.conn;
            int i = 1;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(i++, esp.getEsp_vlEmprestimo());
            ps.setDouble(i++, esp.getEsp_vlAmortizacao());
            ps.setDouble(i++, esp.getEsp_vlJuros());
            ps.setDouble(i++, esp.getEsp_tcm_id());
            ps.setDouble(i++, esp.getEsp_vlSaldoDevedor());
            ps.setInt(i++, esp.getEsp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select esp_id, esp_em_id, esp_ep_id,  esp_vlEmprestimo, esp_vlAmortizacao, "
                    + "esp_vlJuros, esp_vlSaldoDevedor, esp_te_id from amortizacao");
            rs = ps.executeQuery();
            List<Amortizacao> lista = new ArrayList<Amortizacao>();
            while (rs.next()) {
                Amortizacao esp = new Amortizacao(0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
                esp.setEsp_id(rs.getInt(1));
                esp.setEsp_em_id(rs.getInt(2));
                esp.setEsp_ep_id(rs.getInt(3));
                esp.setEsp_vlEmprestimo(rs.getDouble(4));
                esp.setEsp_vlAmortizacao(rs.getDouble(5));
                esp.setEsp_vlJuros(rs.getDouble(6));
                esp.setEsp_vlSaldoDevedor(rs.getDouble(7));
                esp.setEsp_tcm_id(rs.getInt(8));
                lista.add(esp);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection connei = null;
        ResultSet rs = null;
        try {
            connei = this.conn;
            ps = connei.prepareStatement("select esp_id, esp_em_id, esp_ep_id, esp_vlEmprestimo, esp_vlAmortizacao, "
                    + "esp_vlJuros, esp_vlSaldoDevedor, esp_te_id from amortizacao where esp_id=?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Amortizacao> lista = new ArrayList<Amortizacao>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            while (rs.next()) {
                Amortizacao esp = new Amortizacao(0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
                esp.setEsp_id(rs.getInt(1));
                esp.setEsp_em_id(rs.getInt(2));
                esp.setEsp_ep_id(rs.getInt(3));
                esp.setEsp_vlEmprestimo(rs.getDouble(4));
                esp.setEsp_vlAmortizacao(rs.getDouble(5));
                esp.setEsp_vlJuros(rs.getDouble(6));
                esp.setEsp_vlSaldoDevedor(rs.getDouble(7));
                esp.setEsp_tcm_id(rs.getInt(8));

                lista.add(esp);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(connei, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public Amortizacao getByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection connei = null;
        ResultSet rs = null;
        try {
            connei = this.conn;
            ps = connei.prepareStatement(" select esp_id, esp_em_id, esp_ep_id, esp_vlEmprestimo, esp_vlAmortizacao, "
                    + " esp_vlJuros, esp_vlSaldoDevedor, esp_tcm_id from amortizacao where esp_em_id=? ");
            ps.setInt(1, em_id);
            System.out.println(ps);
            rs = ps.executeQuery();


            Amortizacao esp = new Amortizacao(0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
            
            if (rs.getFetchSize() > 0) {
                int i = 1;
                esp.setEsp_id(rs.getInt(i++));
                esp.setEsp_em_id(rs.getInt(i++));
                esp.setEsp_ep_id(rs.getInt(i++));
                esp.setEsp_vlEmprestimo(rs.getDouble(i++));
                esp.setEsp_vlAmortizacao(rs.getDouble(i++));
                esp.setEsp_vlJuros(rs.getDouble(i++));
                esp.setEsp_vlSaldoDevedor(rs.getDouble(i++));
                esp.setEsp_tcm_id(rs.getInt(i++));
            }

            return esp;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(connei, ps, rs);
        }
    }

    /**
     *
     * @param pe_id
     * @param tcm_id
     * @param comConexao
     * @return
     * @throws JogosDAOException
     */
    public Amortizacao getTotalPeriodo(int pe_id, int tcm_id, String comConexao) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection connei = null;
        ResultSet rs = null;
        try {
            connei = this.conn;
            String sql = " select sum(esp_vlAmortizacao) as vlr, sum(esp_vlJuros) as vlr_juros, "
                    + " (select sum(ep_vlEmprestimo) from emprestimo where ep_em_id =esp_em_id) as vl_emprestimo "
                    + " from amortizacao a "
                    + " join empresa_periodo em on a.esp_em_id = em.em_id "
                    + "where em.em_pe_id = " + pe_id + " and esp_tcm_id = " + tcm_id;
            ps = connei.prepareStatement(sql);

            rs = ps.executeQuery();
            ps = connei.prepareStatement(sql);


            rs = ps.executeQuery();
            Amortizacao esp = new Amortizacao(0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
            if (rs.next()) {
//                throw new JogosDAOException("Nao foi encontrado nenhum registro com Amortização : " + em_id);
                int i = 1;
                esp.setEsp_vlAmortizacao(rs.getDouble(i++));
                esp.setEsp_vlJuros(rs.getDouble(i++));
                esp.setEsp_vlEmprestimo(rs.getDouble(i++));
            }
            return esp;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            if (comConexao.equals("S")) {
                ConexaoFactory.closeConnection(connei, ps, rs);
            }
        }
    }
}
