/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.CompraMP;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class CompraMPDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public CompraMPDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param e
     * @throws JogosDAOException
     */
    public void salvar(CompraMP e) throws JogosDAOException {

        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (e == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        //System.out.println("não era nulo..");
        try {
            String SQL = "insert into compramp (cmp_em_id, cmp_tcm_id) "
                    + "values (?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, e.getCmp_em_id());
            ps.setInt(2, e.getCmp_tcm_id());
            ps.executeUpdate();


//            PagtoMpDAO pgt = new PagtoMpDAO();
  //          pgt.creaPgtoMp(e);
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param e
     * @throws JogosDAOException
     */
    public void excluir(CompraMP e) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (e == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from compramp where e_id=?");
            ps.setInt(1, e.getCmp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param e
     * @throws JogosDAOException
     */
    public void atualizar(CompraMP e) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (e == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = " update compramp set "
                    + " cmp_em_id = ?, "
                    + " cmp_tcm_id = ? "
                    + " where cmp_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, e.getCmp_em_id());
            ps.setInt(2, e.getCmp_tcm_id());
            ps.setInt(3, e.getCmp_id());
            ps.executeUpdate();

    //        PagtoMpDAO pgt = new PagtoMpDAO();

      //      pgt.creaPgtoMp(e);
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cmp_id, cmp_em_id, cmp_tcm_id"
                    + " from compramp");
            rs = ps.executeQuery();
            List<CompraMP> lista = new ArrayList<CompraMP>();
            while (rs.next()) {
                CompraMP e = new CompraMP(0, 0, 0);
                e.setCmp_id(rs.getInt(1));
                e.setCmp_em_id(rs.getInt(2));
                e.setCmp_tcm_id(rs.getInt(3));

                lista.add(e);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cmp_id, cmp_em_id, cmp_tcm_id "
                    + " from compramp where cmp_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<CompraMP> lista = new ArrayList<CompraMP>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }

            CompraMP e = new CompraMP(0, 0, 0);
            e.setCmp_id(rs.getInt(1));
            e.setCmp_em_id(rs.getInt(2));
            e.setCmp_tcm_id(rs.getInt(3));
            lista.add(e);

            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public List listaByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cmp_id, cmp_em_id, cmp_tcm_id "
                    + " from compramp where cmp_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            List<CompraMP> lista = new ArrayList<CompraMP>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }

            CompraMP e = new CompraMP(0, 0, 0);
            e.setCmp_id(rs.getInt(1));
            e.setCmp_em_id(rs.getInt(2));
            e.setCmp_tcm_id(rs.getInt(3));
            lista.add(e);

            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public CompraMP getByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cmp_id, cmp_em_id, cmp_tcm_id "
                    + " from compramp where cmp_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            CompraMP obj;
            if (!rs.next()) {
                obj = new CompraMP(0, 0, 0);
            } else {

                obj = new CompraMP(0, 0, 0);
                obj.setCmp_id(rs.getInt(1));
                obj.setCmp_em_id(rs.getInt(2));
                obj.setCmp_tcm_id(rs.getInt(3));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select * from compramp where cmp_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro.");
            }

            while (rs.next()) {
                SelectItem compramp = new SelectItem(rs.getString(3));
                lista.add(compramp);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param pe_id
     * @param tcm_id
     * @return
     * @throws SQLException
     */
    public double getTotalPeridoTipo(int pe_id, int tcm_id) throws SQLException {
        String sql = "select sum(coalesce(pmp_vlPagar, 0)) as total from empresa_periodo ep "
                + "left join compramp c on c.cmp_em_id = ep.em_id                  "
                + "left join tipocompramp t on t.tcm_id = c.cmp_tcm_id "
                + "left join pgtomp p on c.cmp_id = p.pmp_cmp_id "
                + "left join periodo pe on pe.pe_noPeriodo = p.pmp_pe_noPeriodo "
                + "where pe_id = "+ pe_id +" and c.cmp_tcm_id = "+tcm_id;

        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;

        conne = this.conn;
        ps = conne.prepareStatement(sql);

        rs = ps.executeQuery();
        if(!rs.next())
            return 0.0;
        
        return rs.getDouble(1);
    }
}
