package dao;

import entidades.CapacidadeProducao;
import entidades.CompraVendaMaquina;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

public class CompraVendaMaquinaDAO  {

    private Connection conn;


    public CompraVendaMaquinaDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    public void atualizar(CompraVendaMaquina cvm) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (cvm == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update compra_venda_maquina set "
                    + "cvm_pe_id = ?, "
                    + "cvm_em_id = ?, "
                    + "cvm_tm_id = ?, "
                    + "cvm_noTipoTransacao = ?, "
                    + "cvm_nrQtde = ? "
                    + "where cvm_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, cvm.getCvm_pe_id());
            ps.setInt(2, cvm.getCvm_em_id());
            ps.setInt(3, cvm.getCvm_tm_id());
            ps.setString(4, cvm.getCvm_noTipoTransacao());
            ps.setInt(5, cvm.getCvm_nrQtde());
            ps.setInt(6, cvm.getCvm_id());

            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    public CompraVendaMaquina selectByEmpTipo(int em_id, int tm_id, String noTipoTransacao) throws JogosDAOException{
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cvm_id, cvm_pe_id, cvm_em_id, cvm_tm_id, cvm_noTipoTransacao, cvm_nrQtde from compra_venda_maquina where cvm_em_id = ? and cvm_tm_id = ? and cvm_noTipoTransacao = ?");
            ps.setInt(1, em_id);
            ps.setInt(2, tm_id);
            ps.setString(3, noTipoTransacao);
            rs = ps.executeQuery();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }

            CompraVendaMaquina cvm = new CompraVendaMaquina();
            int i = 1;
            cvm.setCvm_id(rs.getInt(i++));
            cvm.setCvm_pe_id(rs.getInt(i++));
            cvm.setCvm_em_id(rs.getInt(i++));
            cvm.setCvm_tm_id(rs.getInt(i++));
            cvm.setCvm_noTipoTransacao(rs.getString(i++));
            cvm.setCvm_nrQtde(rs.getInt(i++));
            return cvm;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    public int qtdeTransacao(int pe_id, int tm_id, String noTransacao) throws JogosDAOException{
        int qtCompra = 0;
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT SUM(cvm_nrQtde) as qtCompra FROM compra_venda_maquina WHERE cvm_pe_id = " + pe_id + " AND cvm_tm_id= " + tm_id + " AND cvm_noTipoTransacao = '" + noTransacao + "'";
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            if (rs.next()) {
                qtCompra = rs.getInt(1);
            }
            return qtCompra;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

}
