/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.CustosFixo;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class CustosFixoDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public CustosFixoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param cf
     * @throws JogosDAOException
     */
    public void salvar(CustosFixo cf) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (cf == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into custosfixo (cf_em_id, cf_vlTreinamento, cf_vlEstMP,"
                    + "cf_vlDeprecMaq, cf_vlDeprecPredio) "
                    + "values (?,?,?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, cf.getCf_em_id());
            ps.setDouble(2, cf.getCf_vlTreinamento());
            ps.setDouble(3, cf.getCf_vlEstMP());
            ps.setDouble(4, cf.getCf_vlDeprecMaq());
            ps.setDouble(5, cf.getCf_vlDeprecPredio());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param cf
     * @throws JogosDAOException
     */
    public void excluir(CustosFixo cf) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (cf == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from custosfixo where cf_id=?");
            ps.setInt(1, cf.getCf_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param cf
     * @throws JogosDAOException
     */
    public void atualizar(CustosFixo cf) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (cf == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update custosfixo set "
                    + "cf_vlTreinamento= ? "
                    + "cf_vlEstMP= ? "
                    + "cf_vlDeprecMaq= ? "
                    + "cf_vlDeprecPredio= ? "
                    + "where cf_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(1, cf.getCf_vlTreinamento());
            ps.setDouble(2, cf.getCf_vlEstMP());
            ps.setDouble(3, cf.getCf_vlDeprecMaq());
            ps.setDouble(4, cf.getCf_vlDeprecPredio());
            ps.setInt(5, cf.getCf_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cf_id, cf_em_id, cf_vlTreinamento, cf_vlEstMP, "
                    + "cf_vlDeprecMaq, cf_vlDeprecPredio from custosfixo");
            rs = ps.executeQuery();
            List<CustosFixo> lista = new ArrayList<CustosFixo>();
            while (rs.next()) {
                CustosFixo cf = new CustosFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
                cf.setCf_id(rs.getInt(1));
                cf.setCf_em_id(rs.getInt(2));
                cf.setCf_vlTreinamento(rs.getDouble(3));
                cf.setCf_vlEstMP(rs.getDouble(4));
                cf.setCf_vlDeprecMaq(rs.getDouble(5));
                cf.setCf_vlDeprecPredio(rs.getDouble(6));
                lista.add(cf);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cf_id, cf_em_id, cf_vlTreinamento, cf_vlEstMP, "
                    + "cf_vlDeprecMaq, cf_vlDeprecPredio from custosfixo where cf_id=?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<CustosFixo> lista = new ArrayList<CustosFixo>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            while (rs.next()) {
                CustosFixo cf = new CustosFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
                cf.setCf_id(rs.getInt(1));
                cf.setCf_em_id(rs.getInt(2));
                cf.setCf_vlTreinamento(rs.getDouble(3));
                cf.setCf_vlEstMP(rs.getDouble(4));
                cf.setCf_vlDeprecMaq(rs.getDouble(5));
                cf.setCf_vlDeprecPredio(rs.getDouble(6));
                lista.add(cf);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param cf_em_id
     * @return
     * @throws JogosDAOException
     */
    public CustosFixo getByEmpresaPeriodo(int cf_em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select cf_em_id, cf_em_id, cf_vlTreinamento, cf_vlEstMP, "
                    + "cf_vlDeprecMaq, cf_vlDeprecPredio from custosfixo where cf_em_id=?");
            ps.setInt(1, cf_em_id);
            rs = ps.executeQuery();
            CustosFixo cf = new CustosFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
            if (rs.next()) {
                cf.setCf_id(rs.getInt(1));
                cf.setCf_em_id(rs.getInt(2));
                cf.setCf_vlTreinamento(rs.getDouble(3));
                cf.setCf_vlEstMP(rs.getDouble(4));
                cf.setCf_vlDeprecMaq(rs.getDouble(5));
                cf.setCf_vlDeprecPredio(rs.getDouble(6));
            }
            return cf;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
    
}
