/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Empresa;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class EmpresaDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public EmpresaDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param e
     * @throws JogosDAOException
     */
    public void salvar(Empresa e) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (e == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into empresa (e_descr) "
                    + "values (?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setString(1, e.getE_descr());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param e
     * @throws JogosDAOException
     */
    public void excluir(Empresa e) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (e == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from empresa where e_id=?");
            ps.setInt(1, e.getE_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param e
     * @throws JogosDAOException
     */
    public void atualizar(Empresa e) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (e == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update empresa set "
                    + "e_descr = ? "
                    + "where e_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(2, e.getE_id());
            ps.setString(1, e.getE_descr());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select e_id, e_descr "
                    + " from empresa");
            rs = ps.executeQuery();
            List<Empresa> lista = new ArrayList<Empresa>();
            while (rs.next()) {
                Empresa e = new Empresa(0, "");
                e.setE_id(rs.getInt(1));
                e.setE_descr(rs.getString(2));

                lista.add(e);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public Empresa listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            if(id > 0){
                ps = conne.prepareStatement("select e_id, e_descr "
                    + " from empresa where e_id = ?");
                ps.setInt(1, id);
            }else{
                ps = conne.prepareStatement("select e_id, e_descr "
                    + " from empresa where e_id = (select min(e_id) from empresa)");
            }
            rs = ps.executeQuery();
            if (!rs.next()) {
                throw new JogosDAOException("Erro class EmpresaDAO Empresa listaById" + id);
            }
            Empresa e = new Empresa(0, "");
            e.setE_id(rs.getInt(1));
            e.setE_descr(rs.getString(2));
            return e;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select e_id, e_descr from empresa");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro.");
            }

            while (rs.next()) {
                SelectItem empresa = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(empresa);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
