/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.PreparedStatement;
import entidades.Fluxocaixa;
import java.sql.ResultSet;
import java.sql.SQLException;

import util.ConexaoFactory;

/**
 *
 * @author rafael
 */
public class FluxocaixaDAO {

    private Connection conn;
    private String campos_sql = " fx_em_id, "
            + "fx_vlAplicacao, "
            + "fx_vlResgAplicacao, "
            + "fx_vlDescDuplicatas, "
            + "fx_pcJurosVdPz, "
            + "fx_vlDiversos, "
            + "fx_vlSaldoInicial, "
            + "fx_vlSaldoFinal, "
            + "fx_vlAtrasos, "
            + "fx_vlInadimplencia";
    private String tabela = " fluxocaixa ";
    private String tbl_id = " fx_id ";

    /**
     *
     * @throws JogosDAOException
     */
    public FluxocaixaDAO() throws JogosDAOException {
        try {
            this.conn = (Connection) ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param obj
     * @throws JogosDAOException
     * @throws SQLException
     */
    public void salvar(Fluxocaixa obj) throws JogosDAOException, SQLException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo fluxocaixa - ins.");
        }

        try {
            String SQL = "insert into "+tabela+" (" + campos_sql + ") "
                    + "values (?,?,?,?,?,?,?,?,?,?)";
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, obj.getFx_em_id());
            ps.setDouble(i++, obj.getFx_vlAplicacao());
            ps.setDouble(i++, obj.getFx_vlResgAplicacao());
            ps.setDouble(i++, obj.getFx_vlDescDuplicatas());
            ps.setDouble(i++, obj.getFx_pcJurosVdPz());
            ps.setDouble(i++, obj.getFx_vlDiversos());
            ps.setDouble(i++, obj.getFx_vlSaldoInicial());
            ps.setDouble(i++, obj.getFx_vlSaldoFinal());
            ps.setDouble(i++, obj.getFx_vlInadimplencia());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param id
     * @throws JogosDAOException
     */
    public void excluir(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (id > 0) {
            throw new JogosDAOException("O valor passado não pode ser nulo fluxo caixa - exc.");
        }

        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("delete from "+tabela+" where rb_id=?");
            ps.setInt(1, id);
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(Fluxocaixa obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }
        String SQL ="";
        try {
            SQL = " update "+tabela+" set  "
                    + " fx_vlAplicacao = ?, "
                    + " fx_vlResgAplicacao = ?, "
                    + " fx_vlDescDuplicatas = ?, "
                    + " fx_pcJurosVdPz = ?, "
                    + " fx_vlDiversos = ?, "
                    + " fx_vlSaldoInicial = ?, "
                    + " fx_vlSaldoFinal = ?, "
                    + " fx_vlAtrasos = ?,"
                    + " fx_vlInadimplencia = ?"
                    + " where fx_id = ?";
            conne = this.conn;

            ps = (PreparedStatement) conne.prepareStatement(SQL);
            int i = 1;
            ps.setDouble(i++, obj.getFx_vlAplicacao());
            ps.setDouble(i++, obj.getFx_vlResgAplicacao());
            ps.setDouble(i++, obj.getFx_vlDescDuplicatas());
            ps.setDouble(i++, obj.getFx_pcJurosVdPz());
            ps.setDouble(i++, obj.getFx_vlDiversos());
            ps.setDouble(i++, obj.getFx_vlSaldoInicial());
            ps.setDouble(i++, obj.getFx_vlSaldoFinal());
            ps.setDouble(i++, obj.getFx_vlAtrasos());
            ps.setDouble(i++, obj.getFx_vlInadimplencia());
            ps.setInt(i++, obj.getFx_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException(SQL+"Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public Fluxocaixa getByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
    
            conne = this.conn;
            String sql = "select " + tbl_id + ", " + campos_sql + " from "+tabela+" where fx_em_id = ? ";
            ps = (PreparedStatement) conne.prepareStatement(sql);
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            
            Fluxocaixa obj = new Fluxocaixa(0, 0, 0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
            int i;
            if (!rs.next()) {
                System.out.println("Erro ao ler a tabela "+tabela+" - "+campos_sql+".");
            } else {
                i = 1;
                obj.setFx_id(rs.getInt(i++));
                obj.setFx_em_id(rs.getInt(i++));
                obj.setFx_vlAplicacao(rs.getDouble(i++));
                obj.setFx_vlResgAplicacao(rs.getDouble(i++));
                obj.setFx_vlDescDuplicatas(rs.getDouble(i++));
                obj.setFx_pcJurosVdPz(rs.getDouble(i++));
                obj.setFx_vlDiversos(rs.getDouble(i++));
                obj.setFx_vlSaldoInicial(rs.getDouble(i++));
                obj.setFx_vlSaldoFinal(rs.getDouble(i++));
                obj.setFx_vlAtrasos(rs.getDouble(i++));
                obj.setFx_vlInadimplencia(rs.getDouble(i++));
                obj.calcRecebimentos();
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
   
}
