/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

/**
 *
 * @author rafael
 */
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;
import entidades.Maquina;

/**
 *
 * @author rafael
 */
public class MaquinaDAO {

    private Connection conn;
    /**
     *
     */
    public String campos_sql = " m_tm_id ";
    /**
     *
     */
    public String tbl_id = "m_id";
    /**
     *
     */
    public String tabela = "maquina";

    /**
     *
     * @throws JogosDAOException
     */
    public MaquinaDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(Maquina obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (obj == null) {
            throw new JogosDAOException("O objeto utilizado não pode ser nulo.");
        }

        try {
            String temp = "?";
            for (int i = 1; i < 2; i++) {
                temp += ", ?";
            }

            String SQL = "insert into " + tabela + " (" + campos_sql + ") "
                    + "values (" + temp + ")";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, obj.getM_tm_id());

            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(Maquina obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete." + obj.toString());
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from " + tabela + " where " + tbl_id + "=?");
            ps.setInt(1, obj.getM_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(Maquina obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update " + tabela + " set "
                    + " m_tm_id = ? where " + tbl_id + " = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, obj.getM_tm_id());
            ps.setInt(2, obj.getM_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " + campos_sql + " from " + tabela);
            rs = ps.executeQuery();
            List<Maquina> lista = new ArrayList<Maquina>();
            while (rs.next()) {
                Maquina obj = new Maquina(0, 0);
                obj.setM_id(rs.getInt(1));
                obj.setM_tm_id(rs.getInt(2));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

 
     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " + campos_sql + " from " + tabela + " where " + tbl_id + " = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Maquina> lista = new ArrayList<Maquina>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            while (rs.next()) {
                Maquina obj = new Maquina(0, 0);
                obj.setM_id(rs.getInt(1));
                obj.setM_tm_id(rs.getInt(2));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
