/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

/**
 *
 * @author rafael
 */
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;
import entidades.MaquinaPeriodo;

/**
 *
 * @author rafael
 */
public class MaquinaPeriodoDAO{

    private Connection conn;
    /**
     *
     */
    public String campos_sql = " mq_em_id, mq_nrIdade, mq_vlContabil ";
    /**
     *
     */
    public String tbl_id = "mq_id";
    /**
     *
     */
    public String tabela = "maquina_periodo";

    /**
     *
     * @throws JogosDAOException
     */
    public MaquinaPeriodoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(MaquinaPeriodo mq) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (mq == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "insert into maquina_periodo (mq_em_id, mq_tm_id, mq_nrIdade, mq_vlContabil) values "
                    + "(?, "
                    + "?, "
                    + "?, "
                    + "?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, mq.getMq_em_id());
            ps.setInt(2, mq.getMq_tm_id());
            ps.setInt(3, mq.getMq_nrIdade());
            ps.setDouble(4, mq.getMq_vlContabil());

            ps.executeUpdate();
            System.out.println(ps.toString());
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(MaquinaPeriodo obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete." + obj.toString());
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from " + tabela + " where " + tbl_id + "=?");
            ps.setInt(1, obj.getMq_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(MaquinaPeriodo obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update " + tabela + " set "
                    + " mq_em_id  = ?, mq_nrIdade  = ?, mq_vlContabil = ? where " + tbl_id + " = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, obj.getMq_em_id());
            ps.setInt(i++, obj.getMq_nrIdade());
            ps.setDouble(i++, obj.getMq_vlContabil());
            ps.setInt(i++, obj.getMq_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " + tbl_id + ", " + campos_sql + " from " + tabela);
            rs = ps.executeQuery();
            List<MaquinaPeriodo> lista = new ArrayList<MaquinaPeriodo>();
            int i;
            while (rs.next()) {
                MaquinaPeriodo obj = new MaquinaPeriodo(0, 0, "", 0, 0, 0.0, 0.0);
                i = 1;
                obj.setMq_id(rs.getInt(i++));
                obj.setMq_em_id(rs.getInt(i++));
                obj.setMq_nrIdade(rs.getInt(i++));
                obj.setMq_vlContabil(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public List listaByEmpresaPeriodo(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select mq_id, mq_em_id, mq_tm_id, mq_nrIdade, mq_vlContabil, tm_noTipo, tm_pcCustoManut"
                    + " from maquina_periodo left join tipomaquina on mq_tm_id = tm_id "
                    + " where mq_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();

            List<MaquinaPeriodo> lista = new ArrayList<MaquinaPeriodo>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }
            while (rs.next()) {
                MaquinaPeriodo mq = new MaquinaPeriodo(0, 0, "", 0, 0, 0.0, 0.0);
                mq.setMq_id(rs.getInt(1));
                mq.setMq_em_id(rs.getInt(2));
                mq.setMq_tm_id(rs.getInt(3));
                mq.setMq_nrIdade(rs.getInt(4));
                mq.setMq_vlContabil(rs.getDouble(5));
                mq.setTm_noTipo(rs.getString(6));
                mq.setTm_pcCustoManut(rs.getDouble(7));
                lista.add(mq);
                //System.out.println(mq.toString());
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
    
    public List listaByEmpTipo(int em_id, int tm_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select mq_id, mq_em_id, mq_tm_id, mq_nrIdade, mq_vlContabil from maquina_periodo where mq_em_id = ? and mq_tm_id = ? order by mq_nrIdade");
            ps.setInt(1, em_id);
            ps.setInt(2, tm_id);
            rs = ps.executeQuery();
            System.out.println(ps.toString());

            List<MaquinaPeriodo> lista = new ArrayList<MaquinaPeriodo>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }
            while (rs.next()) {
                MaquinaPeriodo mq = new MaquinaPeriodo(0, 0, "", 0, 0, 0.0, 0.0);
                mq.setMq_id(rs.getInt(1));
                mq.setMq_em_id(rs.getInt(2));
                mq.setMq_tm_id(rs.getInt(3));
                mq.setMq_nrIdade(rs.getInt(4));
                mq.setMq_vlContabil(rs.getDouble(5));
                lista.add(mq);
                //System.out.println(mq.toString());
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }



     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " + tbl_id + ", " + campos_sql + " from " + tabela + " where " + tbl_id + " = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<MaquinaPeriodo> lista = new ArrayList<MaquinaPeriodo>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            int i;
            while (rs.next()) {
                MaquinaPeriodo obj = new MaquinaPeriodo(0, 0, "", 0, 0, 0.0, 0.0);
                i = 1;
                obj.setMq_id(rs.getInt(i++));
                obj.setMq_em_id(rs.getInt(i++));
                obj.setMq_nrIdade(rs.getInt(i++));
                obj.setMq_vlContabil(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param em_id
     * @param tm_id
     * @return
     * @throws JogosDAOException
     */
    public int qtdeMaquinasPorTipo(int em_id, int tm_id) throws JogosDAOException{
        int qtMaquinas = 0;
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT COUNT(mq_id) as qtMaquinas FROM maquina_periodo WHERE mq_em_id = " + em_id + " AND mq_tm_id= " + tm_id;
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            if (rs.next()) {
                qtMaquinas = rs.getInt(1);
            }
            return qtMaquinas;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public double totalVlContabil(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "select sum(mq_vlContabil) as totalVlContabil from maquina_periodo where mq_em_id = " + em_id;

            ps = conne.prepareStatement(sql);

            rs = ps.executeQuery();
            double totalVlContabil = 0.0;
            if (rs.next()) {
                totalVlContabil = rs.getDouble(1);
            }
            return totalVlContabil;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
}
