/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

//import classView.TotalPgtoPeriodo;
import entidades.CompraMP;
import entidades.Estoquemp;
import entidades.MateriaPrima;
import entidades.PagtoMp;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class PagtoMpDAO {

    private Connection conn;
    /**
     *
     */
    public String campos_sql = " pmp_cmp_id, pmp_pago, pmp_pe_noPeriodo, pmp_vlPagar ";
    /**
     *
     */
    public String tbl_id = " pmp_id ";
    /**
     *
     */
    public String tabela = " pgtomp ";

    /**
     *
     * @throws JogosDAOException
     */
    public PagtoMpDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @throws JogosDAOException
     */
    public void novaConexao() throws JogosDAOException {
        this.conn = ConexaoFactory.getConnection();
    }

    /**
     *
     * @param pg
     * @throws JogosDAOException
     */
    public void salvar(PagtoMp pg) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pg == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into " + tabela + " (" + campos_sql + ") "
                    + "values (?,?,?,?)";

            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;

            ps.setInt(i++, pg.getPmp_cmp_id());
            ps.setString(i++, pg.getPmp_pago());
            ps.setInt(i++, pg.getPmp_pe_noPeriodo());
            ps.setDouble(i++, pg.getPmp_vlPagar());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param objCp
     * @throws JogosDAOException
     */
    public void creaPgtoMp(CompraMP objCp) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        int cmp_id;
        int noParc;
        //a partir da gravação da compra gera os pagamentos.
        //deleta os pgto que existem e gera os novos.
        if (objCp == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "select c.cmp_id, t.tcm_noParc, pe.pe_noPeriodo, pe.pe_id from compramp c "
                    + "join empresa_periodo em on em.em_id = c.cmp_em_id "
                    + "join periodo pe on pe.pe_id = em.em_pe_id "
                    + "join tipocompramp t on t.tcm_id = c.cmp_tcm_id "
                    + "where em.em_id =  " + objCp.getCmp_em_id();
            conne = this.conn;


            ps = conne.prepareStatement(SQL);

            ResultSet rs = ps.executeQuery();
            if (!rs.next()) {
                throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
            }
            cmp_id = rs.getInt(1);
            noParc = rs.getInt(2);
            int pe_id = rs.getInt(3);
            int noPeriodo = rs.getInt(3);
            PagtoMp objPg = null;
            excluir(cmp_id);//deleta os que existem

            MateriaPrimaDAO idaoMp = new MateriaPrimaDAO();
            MateriaPrima objMp;
            List lMp = idaoMp.listaByPeriodo(pe_id);
            int qtdelmp = lMp.size();
            EstoquempDAO idaoEs = (EstoquempDAO) new EstoquempDAO();
            CompraMPDAO idaoCp = new CompraMPDAO();

            Estoquemp objEsMp = idaoEs.getByEmPr(objCp.getCmp_em_id());
            for (int i = 0; i < qtdelmp; i++) {
                objMp = (MateriaPrima) lMp.get(i);
                if (objMp.getMp_noTipo().equalsIgnoreCase("A")) {
                    objEsMp.setEs_vlCompEspMPA(objEsMp.getEs_vlCompEspMPA() * objMp.getMp_vlPreco());
                    objEsMp.setEs_vlCompProgMPA(objEsMp.getEs_vlCompProgMPA() * objMp.getMp_vlPreco());
                } else {
                    objEsMp.setEs_vlCompEspMPB(objEsMp.getEs_vlCompEspMPA() * objMp.getMp_vlPreco());
                    objEsMp.setEs_vlCompProgMPB(objEsMp.getEs_vlCompProgMPB() * objMp.getMp_vlPreco());
                }
            }
            double totalL = (objEsMp.getEs_vlCompEspMPA() + objEsMp.getEs_vlCompEspMPB()
                    + objEsMp.getEs_vlCompProgMPA() + objEsMp.getEs_vlCompProgMPB()) / noParc;
            for (int i = 0; i < noParc; i++) {
                conne.close();
                novaConexao();
                objPg = new PagtoMp(0, "N", 0, 0.0);
                objPg.setPmp_cmp_id(cmp_id);
                objPg.setPmp_pe_noPeriodo(noPeriodo + i);
                objPg.setPmp_vlPagar(totalL);
                objPg.setPmp_pago("N");
                salvar(objPg);
            }

        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param cmp_id
     * @throws JogosDAOException
     */
    public void excluir(int cmp_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from pgtomp where pmp_cmp_id = ?");
            ps.setInt(1, cmp_id);
            ps.executeUpdate();
            conne.close();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param empresa
     * @param tipocompramp
     * @return
     * @throws JogosDAOException
     */
   /* public List totalPgtoPeriodo(int empresa, String tipocompramp) throws JogosDAOException {
        String sql = "select ep.em_pe_id as pe_id, t.tcm_id, sum(coalesce(p.pmp_vlPagar, 0)) as vlr from empresa_periodo ep "
                + "left join compramp c on c.cmp_em_id = ep.em_id "
                + "left join tipocompramp t on t.tcm_id = c.cmp_tcm_id "
                + "left join pgtomp p on c.cmp_id = p.pmp_cmp_id where t.tcm_enTipo = ? and ep.em_id = ? "
                + "group by ep.em_pe_id, t.tcm_id order by 1";
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement(sql);
            ps.setString(1, tipocompramp);
            ps.setInt(2, empresa);
            rs = ps.executeQuery();
            List<TotalPgtoPeriodo> lista = new ArrayList<TotalPgtoPeriodo>();

            if (rs == null) {
                throw new JogosDAOException("Nenhum pagamento gerado até o momento: ");
            }
            TotalPgtoPeriodo obj = null;
            while (rs.next()) {
                obj = new TotalPgtoPeriodo(0.0, 0.0, 0.0, 0, 0);
                obj.setPmp_pe_noPeriodo(rs.getInt(1));
                obj.setVlpagar(rs.getDouble(2));
                obj.setCmp_tcm_id(rs.getInt(3));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }*/
}
