/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.ParamVariavel;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class ParamVariavelDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public ParamVariavelDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param pvl
     * @throws JogosDAOException
     */
    public void salvar(ParamVariavel pvl) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (pvl == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into paramvariavel ("
                    + "pv_pe_id,"
                    + "pv_vlDistLoc,"
                    + "pv_vlDistExt,"
                    + "pv_vlPropag,"
                    + "pv_pcJuros,"
                    + "pv_pcTR,"
                    + "pv_tu_id,"
                    + "pv_nrPeriodo) values (?,?,?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, pvl.getPv_pe_id());
            ps.setDouble(2, pvl.getPv_vlDistLoc());
            ps.setDouble(3, pvl.getPv_vlDistExt());
            ps.setDouble(4, pvl.getPv_vlPropag());
            ps.setDouble(5, pvl.getPv_pcJuros());
            ps.setDouble(6, pvl.getPv_pcTR());
            ps.setDouble(7, pvl.getPv_tu_id());
            ps.setDouble(8, pvl.getPv_nrPeriodo());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param pvl
     * @throws JogosDAOException
     */
    public void excluir(ParamVariavel pvl) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pvl == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from paramvariavel where pv_id=?");
            ps.setInt(1, pvl.getPv_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param pvl
     * @throws JogosDAOException
     */
    public void atualizar(ParamVariavel pvl) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pvl == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update paramvariavel set "
                    + "pv_pe_id = ?,"
                    + "pv_vlDistLoc = ?,"
                    + "pv_vlDistExt = ?,"
                    + "pv_vlPropag = ?,"
                    + "pv_pcJuros = ?,"
                    + "pv_pcTR = ?,"
                    + "pv_tu_id = ?,"
                    + "pv_nrPeriodo = ? where pv_id = ? ";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, pvl.getPv_pe_id());
            ps.setDouble(2, pvl.getPv_vlDistLoc());
            ps.setDouble(3, pvl.getPv_vlDistExt());
            ps.setDouble(4, pvl.getPv_vlPropag());
            ps.setDouble(5, pvl.getPv_pcJuros());
            ps.setDouble(6, pvl.getPv_pcTR());
            ps.setDouble(7, pvl.getPv_tu_id());
            ps.setDouble(8, pvl.getPv_nrPeriodo());
            ps.setInt(9, pvl.getPv_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados ParamVariavel atualizar " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public ParamVariavel listaByPeriodo(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;

        try {
            conne = this.conn;
            ps = conne.prepareStatement("select "
                    + "pv_id,"
                    + "pv_pe_id,"
                    + "pv_vlDistLoc,"
                    + "pv_vlDistExt,"
                    + "pv_vlPropag,"
                    + "pv_pcJuros,"
                    + "pv_pcTR,"
                    + "pv_tu_id,"
                    + "pv_nrPeriodo"
                    + "  from paramvariavel where pv_pe_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            ParamVariavel pvl = new ParamVariavel();
            while (rs.next()) {
                pvl.setPv_id(rs.getInt(1));
                pvl.setPv_pe_id(rs.getInt(2));
                pvl.setPv_vlDistLoc(rs.getDouble(3));
                pvl.setPv_vlDistExt(rs.getDouble(4));
                pvl.setPv_vlPropag(rs.getDouble(5));
                pvl.setPv_pcJuros(rs.getDouble(6));
                pvl.setPv_pcTR(rs.getDouble(7));
                pvl.setPv_tu_id(rs.getInt(8));
                pvl.setPv_nrPeriodo(rs.getInt(9));
            }
            return pvl;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
