/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Pessoal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class PessoalDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public PessoalDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    // 
    /**
     *
     * @param pes
     * @throws JogosDAOException
     */
    public void salvar(Pessoal pes) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pes == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into pessoal (ps_em_id, ps_noSetor, ps_qtEmpregados, ps_qtSalario) "
                    + "values (?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, pes.getPs_em_id());
            ps.setString(2, pes.getPs_noSetor());
            ps.setInt(3, pes.getPs_qtEmpregados());
            ps.setInt(4, pes.getPs_qtSalario());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    // 
    /**
     *
     * @param pes
     * @throws JogosDAOException
     */
    public void excluir(Pessoal pes) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pes == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from pessoal where ps_id = ?");
            ps.setInt(1, pes.getPs_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

   //  
    /**
     *
     * @param pes
     * @throws JogosDAOException
     */
    public void atualizar(Pessoal pes) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pes == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update pessoal set "
                    + "ps_em_id = ?, "
                    + "ps_noSetor = ?, "
                    + "ps_qtEmpregados = ?, "
                    + "ps_qtSalario = ? "
                    + "where ps_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, pes.getPs_em_id());
            ps.setString(2, pes.getPs_noSetor());
            ps.setInt(3, pes.getPs_qtEmpregados());
            ps.setInt(4, pes.getPs_qtSalario());
            ps.setInt(5, pes.getPs_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

  //   
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ps_id, ps_em_id, ps_noSetor, ps_qtEmpregados, "
                    + "ps_qtSalario from pessoal");
            rs = ps.executeQuery();
            List<Pessoal> lista = new ArrayList<Pessoal>();

            while (rs.next()) {
                Pessoal pes = new Pessoal(0, 0, "", 0, 0);
                pes.setPs_id(rs.getInt(1));
                pes.setPs_em_id(rs.getInt(2));
                pes.setPs_noSetor(rs.getString(3));
                pes.setPs_qtEmpregados(rs.getInt(4));
                pes.setPs_qtSalario(rs.getInt(5));
                lista.add(pes);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

   //  
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ps_id, ps_em_id, ps_noSetor, ps_qtEmpregados, "
                    + "ps_qtSalario from pessoal where ps_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Pessoal> lista = new ArrayList<Pessoal>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }

            while (rs.next()) {
                Pessoal pes = new Pessoal(0, 0, "", 0, 0);
                pes.setPs_id(rs.getInt(1));
                pes.setPs_em_id(rs.getInt(2));
                pes.setPs_noSetor(rs.getString(3));
                pes.setPs_qtEmpregados(rs.getInt(4));
                pes.setPs_qtSalario(rs.getInt(5));
                lista.add(pes);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

  //   
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public List listaByEpPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ps_id, ps_em_id, "
                    + " case when ps_noSetor = 'Adm' then 'Administração'"
                    + "      when ps_noSetor = 'Producao' then 'Produção' "
                    + "      when ps_noSetor = 'Vendas' then 'Vendas' "
                    + "      else 'Não definido' end as ps_noSetor , "
                    + "ps_qtEmpregados, "
                    + "ps_qtSalario from pessoal where ps_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            List<Pessoal> lista = new ArrayList<Pessoal>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }

            while (rs.next()) {
                Pessoal pes = new Pessoal(0, 0, "", 0, 0);
                pes.setPs_id(rs.getInt(1));
                pes.setPs_em_id(rs.getInt(2));
                pes.setPs_noSetor(rs.getString(3));
                pes.setPs_qtEmpregados(rs.getInt(4));
                pes.setPs_qtSalario(rs.getInt(5));
                lista.add(pes);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param em_id
     * @param noSetor
     * @return
     * @throws JogosDAOException
     */
    public Pessoal pessoalBySetor(int em_id, String noSetor) throws JogosDAOException{
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "select * from pessoal where ps_noSetor = '" + noSetor + "' and ps_em_id = " + em_id;

            ps = conne.prepareStatement(sql);

            rs = ps.executeQuery();
            Pessoal pes = new Pessoal(0, 0, "", 0, 0);
            if (rs.next()) {
                pes.setPs_id(rs.getInt(1));
                pes.setPs_em_id(rs.getInt(2));
                pes.setPs_noSetor(rs.getString(3));
                pes.setPs_qtEmpregados(rs.getInt(4));
                pes.setPs_qtSalario(rs.getInt(5));
            }
            return pes;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }

    }

  /*  public static void main (String args[]) throws JogosDAOException{
        PessoalDAO teste = new PessoalDAO();
        Pessoal p = teste.pessoalBySetor(106, "Producao");
        System.out.println(
                p.getPs_noSetor() + "\n" +
                p.getPs_em_id() + "\n" +
                p.getPs_qtEmpregados() + "\n" +
                p.getPs_qtSalario()
                );

    }*/

}
