/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Recebimento;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class RecebimentoDAO {

    private Connection conn;
    private String campos_sql = " rb_em_id, rb_tcm_id, rb_vlTipo, rb_tu_id, rb_nrPeriodo, rb_nrEmpresa, rb_nrRegiao ";
    private String tabela = " recebimento ";
    private String tbl_id = " rb_id ";

    /**
     *
     * @throws JogosDAOException
     */
    public RecebimentoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param recebimento
     * @throws JogosDAOException
     */
    public void salvar(Recebimento recebimento) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (recebimento == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into recebimento (" + campos_sql + ") "
                    + "values (?,?,?,?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, recebimento.getRb_em_id());
            ps.setInt(i++, recebimento.getRb_tcm_id());
            ps.setDouble(i++, recebimento.getRb_vlTipo());
            ps.setInt(i++, recebimento.getRb_tu_id());
            ps.setInt(i++, recebimento.getRb_nrPeriodo());
            ps.setInt(i++, recebimento.getRb_nrEmpresa());
            ps.setInt(i++, recebimento.getRb_nrRegiao());

            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param recebimento
     * @throws JogosDAOException
     */
    public void excluir(Recebimento recebimento) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (recebimento == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from recebimento where rb_id=?");
            ps.setInt(1, recebimento.getRb_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(Recebimento obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update recebimento set  rb_em_id = ? ,"
                    + " rb_tcm_id = ? ,"
                    + " rb_vlTipo = ?, "
                    + " rb_tu_id = ?, "
                    + " rb_nrPeriodo = ?, "
                    + " rb_nrEmpresa = ?, "
                    + " rb_nrRegiao = ? "
                    + " where rb_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, obj.getRb_em_id());
            ps.setInt(i++, obj.getRb_tcm_id());
            ps.setDouble(i++, obj.getRb_vlTipo());
            ps.setInt(i++, obj.getRb_tu_id());
            ps.setInt(i++, obj.getRb_nrPeriodo());
            ps.setInt(i++, obj.getRb_nrEmpresa());
            ps.setInt(i++, obj.getRb_nrRegiao());
            ps.setInt(i++, obj.getRb_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " + tbl_id + ", " + campos_sql + " from recebimento where rb_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Recebimento> lista = new ArrayList<Recebimento>();
            Recebimento obj;
            int i;
            while (rs.next()) {
                obj = new Recebimento(0, 0, 0, 0.0,0,0,0,0);
                i = 1;
                obj.setRb_id(rs.getInt(i++));
                obj.setRb_em_id(rs.getInt(i++));
                obj.setRb_tcm_id(rs.getInt(i++));
                obj.setRb_vlTipo(rs.getDouble(i++));
                obj.setRb_tu_id(rs.getInt(i++));
                obj.setRb_nrPeriodo(rs.getInt(i++));
                obj.setRb_nrEmpresa(rs.getInt(i++));
                obj.setRb_nrRegiao(rs.getInt(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public Recebimento getByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            String sql = "select " + tbl_id + ", " + campos_sql + " from recebimento where rb_em_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(sql);
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            List<Recebimento> lista = new ArrayList<Recebimento>();
            Recebimento obj = new Recebimento(0, 0, 0, 0.0,0,0,0,0);
            int i;
            if (!rs.next()) {
                throw new JogosDAOException("Erro ao ler a tabela recebimento - RecebimentoDAO.");
            } else {
                i = 1;
                obj.setRb_id(rs.getInt(i++));
                obj.setRb_em_id(rs.getInt(i++));
                obj.setRb_tcm_id(rs.getInt(i++));
                obj.setRb_vlTipo(rs.getDouble(i++));
                obj.setRb_tu_id(rs.getInt(i++));
                obj.setRb_nrPeriodo(rs.getInt(i++));
                obj.setRb_nrEmpresa(rs.getInt(i++));
                obj.setRb_nrRegiao(rs.getInt(i++));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param em_id
     * @param tcm_id
     * @return
     * @throws JogosDAOException
     */
    public double somaRecebimento(int em_id, int tcm_id) throws JogosDAOException {
        double somaRecebimento = 0.0;
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            String sql = "select sum(rb_vlTipo) as somaRecebimento from recebimento where rb_em_id = ? and rb_tcm_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(sql);
            ps.setInt(1, em_id);
            ps.setInt(2, tcm_id);
            rs = ps.executeQuery();
            if (!rs.next()) {
                throw new JogosDAOException("Erro ao ler a tabela recebimento - RecebimentoDAO.");
            } else {
                somaRecebimento = rs.getDouble(1);
            }
            return somaRecebimento;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
