/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Setor;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class SetorDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public SetorDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param setor
     * @throws JogosDAOException
     */
    public void salvar(Setor setor) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (setor == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into setor (se_ep_id, se_noSetor) "
                    + "values (?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);

            ps.setString(2, setor.getSe_noSetor());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
    /**
     *
     * @param setor
     * @throws JogosDAOException
     */
    public void atualizar(Setor setor) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (setor == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update setor set "
                    + "se_ep_id = ?, "
                    + "se_noSetor = ? "
                    + "where se_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);

            ps.setString(2, setor.getSe_noSetor());
            ps.setInt(3, setor.getSe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select se_id, se_noSetor from setor order by 2");
            rs = ps.executeQuery();
            List<Setor> lista = new ArrayList<Setor>();
            Setor setor;
            while (rs.next()) {
                setor = new Setor();
                setor.setSe_id(rs.getInt(1));
                setor.setSe_noSetor(rs.getString(2));
                lista.add(setor);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public Setor listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select se_id, se_noSetor from setor where se_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            
            if (!rs.next()) {
                throw new JogosDAOException("Erro class SetorDAO Setor listaById, id não encontrado ID:" + id);
            }
            Setor setor;
            setor = new Setor();
            setor.setSe_id(rs.getInt(1));
            setor.setSe_noSetor(rs.getString(2));

            return setor;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select se_id, se_noSetor from setor "
                    + "order by se_noSetor");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            while (rs.next()) {
                SelectItem setor = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(setor);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
