/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.TipoCompraMp;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class TipoCompraMpDAO{

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public TipoCompraMpDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    
    /**
     *
     * @param tpcpmq
     * @throws JogosDAOException
     */
    public void salvar(TipoCompraMp tpcpmq) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tpcpmq == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into tipocompramp (tcm_nome) "
                    + "values (?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setString(1, tpcpmq.getTcm_nome());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    
    /**
     *
     * @param tpcpmq
     * @throws JogosDAOException
     */
    public void excluir(TipoCompraMp tpcpmq) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tpcpmq == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }
        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from tipocompramp where tcm_id = ?");
            ps.setInt(1, tpcpmq.getTcm_id());
            int executeUpdate = ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    
    /**
     *
     * @param tpcpmq
     * @throws JogosDAOException
     */
    public void atualizar(TipoCompraMp tpcpmq) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tpcpmq == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update tipocompramp set "
                    + "tcm_nome = ? "
                    + "where tcm_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setString(1, tpcpmq.getTcm_nome());
            ps.setInt(2, tpcpmq.getTcm_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select * from tipocompramp");
            rs = ps.executeQuery();
            List<TipoCompraMp> lista = new ArrayList<TipoCompraMp>();
            while (rs.next()) {
                TipoCompraMp tpcpmq = new TipoCompraMp();
                tpcpmq.setTcm_id(rs.getInt(1));
                tpcpmq.setTcm_nome(rs.getString(2));

                lista.add(tpcpmq);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select * from tipocompramp where tcm_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<TipoCompraMp> lista = new ArrayList<TipoCompraMp>();

            while (rs.next()) {
                TipoCompraMp tpcpmq = new TipoCompraMp();
                tpcpmq.setTcm_id(rs.getInt(1));
                tpcpmq.setTcm_nome(rs.getString(2));

                lista.add(tpcpmq);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    public TipoCompraMp getById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select * from tipocompramp where tcm_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            TipoCompraMp tcm = new TipoCompraMp();

            while (rs.next()) {
                tcm.setTcm_id(rs.getInt(1));
                tcm.setTcm_nome(rs.getString(2));
            }
            return tcm;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    
    /**
     *
     * @param tipo
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu(String tipo) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select tcm_id, tcm_nome from tipocompramp where tcm_enTipo = '"+tipo+"'");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            while (rs.next()) {
                SelectItem objTipo = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(objTipo);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param tipo
     * @return
     * @throws JogosDAOException
     */
    public List<TipoCompraMp> getByTipoLista(String tipo) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select tcm_id, tcm_nome, tcm_noParc, tcm_enTipo from tipocompramp where tcm_enTipo = '"+tipo+"'");
            rs = ps.executeQuery();
            List<TipoCompraMp> lista = new ArrayList<TipoCompraMp>();
            TipoCompraMp  obj = new TipoCompraMp();

            while (rs.next()) {
                obj = new TipoCompraMp();
                obj.setTcm_id(rs.getInt(1));
                obj.setTcm_nome(rs.getString(2));
                obj.setTcm_noParc(rs.getInt(3));
                obj.setTcm_enTipo(rs.getString(4));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    
    /**
     *
     * @param tpcpmqdigitada
     * @return
     * @throws JogosDAOException
     */
    public TipoCompraMp listaByDesc(String tpcpmqdigitada) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select * from tipocompramp where tcm_nome = ? limit 1");
            ps.setString(1, tpcpmqdigitada);
            rs = ps.executeQuery();

            TipoCompraMp tpcpmq = new TipoCompraMp();
            while (rs.next()) {
                tpcpmq.setTcm_id(rs.getInt(1));
                tpcpmq.setTcm_nome(rs.getString(2));
            }
            return tpcpmq;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
