/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.TipoEmprestimo;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class TipoEmprestimoDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public TipoEmprestimoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param tpem
     * @throws JogosDAOException
     */
    public void salvar(TipoEmprestimo tpem) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tpem == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into tipoemprestimo (te_nome, te_nrParcelas) "
                    + "values (?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setString(1, tpem.getTe_nome());
            ps.setInt(2, tpem.getTe_nrParcelas());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param tpem
     * @throws JogosDAOException
     */
    public void excluir(TipoEmprestimo tpem) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tpem == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from tipoemprestimo where te_id=?");
            ps.setInt(1, tpem.getTe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param tpem
     * @throws JogosDAOException
     */
    public void atualizar(TipoEmprestimo tpem) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tpem == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update tipoemprestimo set "
                    + "te_nome = ?, "
                    + "te_nrParcelas = ? "
                    + "where te_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setString(1, tpem.getTe_nome());
            ps.setInt(2, tpem.getTe_nrParcelas());
            ps.setInt(3, tpem.getTe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select te_id,te_nome,te_nrParcelas from tipoemprestimo");
            rs = ps.executeQuery();
            List<TipoEmprestimo> lista = new ArrayList<TipoEmprestimo>();
            while (rs.next()) {
                TipoEmprestimo tpem = new TipoEmprestimo(0, 0, "");
                tpem.setTe_id(rs.getInt(1));
                tpem.setTe_nome(rs.getString(2));
                tpem.setTe_nrParcelas(rs.getInt(3));
                lista.add(tpem);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select te_id,te_nome,te_nrParcelas from tipoemprestimo where te_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<TipoEmprestimo> lista = new ArrayList<TipoEmprestimo>();

            while (rs.next()) {
                TipoEmprestimo tpem = new TipoEmprestimo(0, 0, "");
                tpem.setTe_id(rs.getInt(1));
                tpem.setTe_nome(rs.getString(2));
                tpem.setTe_nrParcelas(rs.getInt(3));

                lista.add(tpem);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select te_id,te_nome from tipoemprestimo");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            while (rs.next()) {
                SelectItem tipo = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(tipo);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param tpemdigitado
     * @return
     * @throws JogosDAOException
     */
    public TipoEmprestimo listaByDesc(String tpemdigitado) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select te_id,te_nome,te_nrParcelas from tipoemprestimo where te_nome = ? limit 1");
            ps.setString(1, tpemdigitado);
            rs = ps.executeQuery();

            TipoEmprestimo tpem = new TipoEmprestimo(0, 0, "");
            while (rs.next()) {
                tpem.setTe_id(rs.getInt(1));
                tpem.setTe_nome(rs.getString(2));
                tpem.setTe_nrParcelas(rs.getInt(3));
            }
            return tpem;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param tipo
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu(String tipo) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select tcm_id, tcm_nome from tipocompramp where tcm_enTipo = '"+tipo+"'");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            while (rs.next()) {
                SelectItem objTipo = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(objTipo);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
    /**
     *
     * @param tipo
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForTipo(String tipo) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select tcm_id, tcm_nome from tipocompramp where tcm_enTipo = '"+tipo+"'");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            while (rs.next()) {
                SelectItem objTipo = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(objTipo);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
