/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.TipoMaquina;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class TipoMaquinaDAO  {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public TipoMaquinaDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }


    /**
     *
     * @param tipm
     * @throws JogosDAOException
     */
    public void salvar(TipoMaquina tipm) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tipm == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into tipomaquina (tm_noTipo, tm_qtCapacidade, tm_qtEmpregados, tm_pcCustoManut, tm_vlInicial )"
                    + " values (?,?,?,?, ?)";
            conne = this.conn;
            int i=1;
            ps = conne.prepareStatement(SQL);
            ps.setString(i++, tipm.getTm_noTipo());
            ps.setInt(i++, tipm.getTm_qtCapacidade());
            ps.setInt(i++, tipm.getTm_qtEmpregados());
            ps.setDouble(i++, tipm.getTm_pcCustoManut());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @param tipm
     * @throws JogosDAOException
     */
    public void excluir(TipoMaquina tipm) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tipm == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from tipomaquina where tm_id=?");
            ps.setInt(1, tipm.getTm_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @param tipm
     * @throws JogosDAOException
     */
    public void atualizar(TipoMaquina tipm) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (tipm == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update tipomaquina set "
                    + "tm_noTipo = ?, "
                    + "tm_qtCapacidade = ?, "
                    + "tm_qtEmpregados = ?, "
                    + "tm_pcCustoManut = ?, "
                    + "tm_vlInicial = ? "
                    + "where tm_id=?";
            conne = this.conn;
            int i = 1;
            ps = conne.prepareStatement(SQL);
            ps.setString(i++, tipm.getTm_noTipo());
            ps.setInt(i++, tipm.getTm_qtCapacidade());
            ps.setInt(i++, tipm.getTm_qtEmpregados());
            ps.setDouble(i++, tipm.getTm_pcCustoManut());
            ps.setInt(i++, tipm.getTm_id());
            ps.setDouble(i++, tipm.getTm_vlInicial());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select tm_id, tm_noTipo, tm_qtCapacidade, tm_qtEmpregados, tm_pcCustoManut, tm_vlInicial from tipomaquina ");
            rs = ps.executeQuery();
            List<TipoMaquina> lista = new ArrayList<TipoMaquina>();
            while (rs.next()) {
                TipoMaquina tpmq = new TipoMaquina(0, "", 0, 0, 0.0, 0.0);
                tpmq.setTm_id(rs.getInt(1));
                tpmq.setTm_noTipo(rs.getString(2));
                tpmq.setTm_qtCapacidade(rs.getInt(3));
                tpmq.setTm_qtEmpregados(rs.getInt(4));
                tpmq.setTm_pcCustoManut(rs.getDouble(5));
                tpmq.setTm_vlInicial(rs.getDouble(6));
                lista.add(tpmq);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;

            ps = conne.prepareStatement("select tm_id, tm_noTipo, tm_qtCapacidade, tm_qtEmpregados, tm_pcCustoManut, tm_vlInicial from tipomaquina left join maquina_periodo on tm_id = mq_tm_id where mq_em_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<TipoMaquina> lista = new ArrayList<TipoMaquina>();
            while (rs.next()) {
                TipoMaquina tpmq = new TipoMaquina(0, "", 0, 0, 0.0, 0.0);
                tpmq.setTm_id(rs.getInt(1));
                tpmq.setTm_noTipo(rs.getString(2));
                tpmq.setTm_qtCapacidade(rs.getInt(3));
                tpmq.setTm_qtEmpregados(rs.getInt(4));
                tpmq.setTm_pcCustoManut(rs.getDouble(5));

                lista.add(tpmq);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select tm_id, tm_noTipo from tipomaquina");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();
            while (rs.next()) {
                SelectItem tipo = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(tipo);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @param tpmqdigitada
     * @return
     * @throws JogosDAOException
     */
    public TipoMaquina listaByDesc(String tpmqdigitada) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select * from tipomaquina where tm_noTipo = ? limit 1");
            ps.setString(1, tpmqdigitada);
            rs = ps.executeQuery();

            TipoMaquina tpmq = new TipoMaquina(0, "", 0, 0, 0.0, 0.0);
            while (rs.next()) {
                tpmq.setTm_id(rs.getInt(1));
                tpmq.setTm_noTipo(rs.getString(2));
                tpmq.setTm_qtCapacidade(rs.getInt(3));
                tpmq.setTm_qtEmpregados(rs.getInt(4));
                tpmq.setTm_pcCustoManut(rs.getDouble(5));

            }
            return tpmq;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param noTipo
     * @return
     * @throws JogosDAOException
     */
    public TipoMaquina byTipo(String noTipo) throws JogosDAOException{
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT * FROM tipomaquina WHERE tm_noTipo = '" + noTipo + "'";
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            TipoMaquina tpmq = new TipoMaquina(0, "", 0, 0, 0.0, 0.0);

            if (rs.next()) {
                tpmq.setTm_id(rs.getInt(1));
                tpmq.setTm_noTipo(rs.getString(2));
                tpmq.setTm_qtCapacidade(rs.getInt(3));
                tpmq.setTm_qtEmpregados(rs.getInt(4));
                tpmq.setTm_pcCustoManut(rs.getDouble(5));
                tpmq.setTm_vlInicial(rs.getDouble(6));
            }
            return tpmq;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    public TipoMaquina byId(int id) throws JogosDAOException{
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT * FROM tipomaquina WHERE tm_id = " + id;
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            TipoMaquina tpmq = new TipoMaquina(0, "", 0, 0, 0.0, 0.0);

            if (rs.next()) {
                tpmq.setTm_id(rs.getInt(1));
                tpmq.setTm_noTipo(rs.getString(2));
                tpmq.setTm_qtCapacidade(rs.getInt(3));
                tpmq.setTm_qtEmpregados(rs.getInt(4));
                tpmq.setTm_pcCustoManut(rs.getDouble(5));
                tpmq.setTm_vlInicial(rs.getDouble(6));
            }
            return tpmq;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

}
