package entidades;

import dao.CustosFixoDAO;
import dao.JogosDAOException;


/**
 *
 * @author rafael
 */
public class CustoMedio {

    private int cm_em_id;

    /**
     *
     * @param cm_em_id
     */
    public CustoMedio(int cm_em_id){
        this.cm_em_id = cm_em_id;
    }

    /**
     *
     * @return
     */
    public int getCm_em_id() {
        return cm_em_id;
    }

    /**
     *
     * @param cm_em_id
     */
    public void setCm_em_id(int cm_em_id) {
        this.cm_em_id = cm_em_id;
    }



    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double totalCustos() throws JogosDAOException{
        double totalCustos = 0.0;
        CustosFixoDAO cfDAO = new CustosFixoDAO();
        CustosFixo cf = cfDAO.getByEmpresaPeriodo(this.cm_em_id);
        CustoVariavel cv = new CustoVariavel(this.cm_em_id);
        EstoqueProdutoAcabado epa = new EstoqueProdutoAcabado(this.cm_em_id);
        totalCustos = cf.totalCustosFixo()+ cv.totalCustoVariavel() + epa.custoEstoqueInicial();
        return totalCustos;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double custoMedioUnitario() throws JogosDAOException{
        double custoMedioUnitario = 0.0;
        EstoqueProdutoAcabado epa = new EstoqueProdutoAcabado(this.cm_em_id);
        custoMedioUnitario = this.totalCustos() / epa.estoqueProdutosDisponiveis();
        return custoMedioUnitario;
    }

    /*public static void main (String args[]) throws JogosDAOException{
        CustoMedio cm = new CustoMedio(9);
        System.out.println(cm.custoMedioUnitario());
    }*/

}
