package entidades;

import dao.EmpresaPeriodoDAO;
import dao.JogosDAOException;
import dao.PeriodoDAO;
import dao.ProdutividadeDAO;



/**
 *
 * @author rafael
 */
public class EstoqueProdutoAcabado {
    private int em_id;

    /**
     *
     * @param em_id
     */
    public EstoqueProdutoAcabado(int em_id){
        this.em_id = em_id;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double estoqueInicial() throws JogosDAOException{
        double vlEstoqueInicial = 0.0;
        EmpresaPeriodoDAO emDAO = new EmpresaPeriodoDAO();
        EmpresaPeriodo em = emDAO.empresaById(this.em_id);
        if (em.empresaPeriodoAnterior() > -1){
           EstoqueProdutoAcabado esI = new EstoqueProdutoAcabado(em.empresaPeriodoAnterior());
           vlEstoqueInicial = esI.estoqueFinal();
        }
        return vlEstoqueInicial;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double estoqueProdutosDisponiveis() throws JogosDAOException{
        double estoqueProdutosDisponiveis = 0.0;
        ProdutividadeDAO prDAO = new ProdutividadeDAO();
        Produtividade pr = prDAO.getById(this.em_id);
        estoqueProdutosDisponiveis = this.estoqueInicial() + pr.producaoFinal();
        return estoqueProdutosDisponiveis;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double estoqueFinal() throws JogosDAOException{
        double vlEstoqueFinal = 0.0;
        ProdutividadeDAO prDAO = new ProdutividadeDAO();
        Produtividade pr = prDAO.getById(this.em_id);
        Receita rc = new Receita();
        vlEstoqueFinal = this.estoqueInicial() + pr.producaoFinal() - rc.totalVendas(this.em_id);
        return vlEstoqueFinal;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double custoEstoqueInicial() throws JogosDAOException{
        double custoEstoqueInicial = 0.0;
        EmpresaPeriodoDAO emDAO = new EmpresaPeriodoDAO();
        EmpresaPeriodo em = emDAO.empresaById(this.em_id);
        if (em.empresaPeriodoAnterior() > -1){
           CustoMedio cm = new CustoMedio(em.empresaPeriodoAnterior());
           custoEstoqueInicial = cm.custoMedioUnitario() * this.estoqueInicial();
        }
        return custoEstoqueInicial;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double estocagemProdutoAcabado() throws JogosDAOException{
        double estocagemProdutoAcabado = 0.0;
        estocagemProdutoAcabado = this.custoEstoqueInicial() * 0.1;
        return estocagemProdutoAcabado;
    }
    /*public static void main (String args[]) throws JogosDAOException{
        EstoqueProdutoAcabado epa = new EstoqueProdutoAcabado(9);
        System.out.println(epa.custoEstoqueInicial());
    }*/


}
