package entidades;

import dao.FolhaPagamentoDAO;
import dao.JogosDAOException;
import dao.PessoalDAO;
import java.io.Serializable;

public class Pessoal implements Serializable{

    private int ps_id;
    private int ps_em_id;
    private String ps_noSetor;
    private int ps_qtEmpregados;
    private int ps_qtSalario;

    public Pessoal(int ps_id, int ps_em_id, String ps_noSetor, int ps_qtEmpregados, int ps_qtSalario) {
        this.ps_id = ps_id;
        this.ps_em_id = ps_em_id;
        this.ps_noSetor = ps_noSetor;
        this.ps_qtEmpregados = ps_qtEmpregados;
        this.ps_qtSalario = ps_qtSalario;
    }

    public Pessoal(Pessoal obj) {
        this.ps_id = obj.getPs_id();
        this.ps_em_id = obj.getPs_em_id();
        this.ps_noSetor = obj.getPs_noSetor();
        this.ps_qtEmpregados = obj.getPs_qtEmpregados();
        this.ps_qtSalario = obj.getPs_qtSalario();
    }

    public int getPs_em_id() {
        return ps_em_id;
    }

    public void setPs_em_id(int ps_em_id) {
        this.ps_em_id = ps_em_id;
    }


    public int getPs_id() {
        return ps_id;
    }

    public void setPs_id(int ps_id) {
        this.ps_id = ps_id;
    }

    public String getPs_noSetor() {
        return ps_noSetor;
    }

    public void setPs_noSetor(String ps_noSetor) {
        this.ps_noSetor = ps_noSetor;
    }

    public int getPs_qtEmpregados() {
        return ps_qtEmpregados;
    }

    public void setPs_qtEmpregados(int ps_qtEmpregados) {
        this.ps_qtEmpregados = ps_qtEmpregados;
    }

    public int getPs_qtSalario() {
        return ps_qtSalario;
    }

    public void setPs_qtSalario(int ps_qtSalario) {
        this.ps_qtSalario = ps_qtSalario;
    }

    public void demitir() throws JogosDAOException{
        FolhaPagamentoDAO fpDAO = new FolhaPagamentoDAO();
        FolhaPagamento fp = fpDAO.getFolhaObj(this.ps_em_id);
        this.ps_qtEmpregados = this.ps_qtEmpregados - fp.getFp_nrDemitidos();
    }

    public void admitir() throws JogosDAOException{
        FolhaPagamentoDAO fpDAO = new FolhaPagamentoDAO();
        FolhaPagamento fp = fpDAO.getFolhaObj(this.ps_em_id);
        this.ps_qtEmpregados = this.ps_qtEmpregados + fp.getFp_nrAdmitidos();
    }

/*    public static void main(String args[]) throws JogosDAOException{
        PessoalDAO peDAO = new PessoalDAO();
        Pessoal pe = peDAO.pessoalBySetor(9, "Producao");
        pe.admitir();
        pe.demitir();
        peDAO = new PessoalDAO();
        peDAO.atualizar(pe);
    }*/

}