package entidades;

import dao.CompraVendaMaquinaDAO;
import dao.JogosDAOException;
import dao.ParamFixoDAO;
import dao.PeriodoDAO;
import dao.TipoMaquinaDAO;
import dao.VariacaoValorMaquinaDAO;
import java.sql.SQLException;
import java.util.Iterator;

public class VariacaoValorMaquina {
    private int vvm_id;
    private int vvm_pe_id;
    private int vvm_tm_id;
    private double vvm_pcVariacao;

    public VariacaoValorMaquina(int vvm_id, int vvm_pe_id, int vvm_tm_id, double vvm_pcVariacao) {
        this.vvm_id = vvm_id;
        this.vvm_pe_id = vvm_pe_id;
        this.vvm_tm_id = vvm_tm_id;
        this.vvm_pcVariacao = vvm_pcVariacao;
    }

    public VariacaoValorMaquina() {
        this.vvm_id = 0;
        this.vvm_pe_id = 0;
        this.vvm_tm_id = 0;
        this.vvm_pcVariacao = 0.0;
    }

    public VariacaoValorMaquina(VariacaoValorMaquina obj){
        this.vvm_id = obj.getVvm_id();
        this.vvm_pe_id = obj.getVvm_pe_id();
        this.vvm_tm_id = obj.getVvm_tm_id();
        this.vvm_pcVariacao = obj.getVvm_pcVariacao();
    }

    public int getVvm_id() {
        return vvm_id;
    }

    public void setVvm_id(int vvm_id) {
        this.vvm_id = vvm_id;
    }

    public double getVvm_pcVariacao() {
        return vvm_pcVariacao;
    }

    public void setVvm_pcVariacao(double vvm_pcVariacao) {
        this.vvm_pcVariacao = vvm_pcVariacao;
    }

    public int getVvm_pe_id() {
        return vvm_pe_id;
    }

    public void setVvm_pe_id(int vvm_pe_id) {
        this.vvm_pe_id = vvm_pe_id;
    }

    public int getVvm_tm_id() {
        return vvm_tm_id;
    }

    public void setVvm_tm_id(int vvm_tm_id) {
        this.vvm_tm_id = vvm_tm_id;
    }

    public void determinarVariacao() throws JogosDAOException{
        int qtCompra = 0;
        int qtVenda = 0;
        PeriodoDAO peDAO = new PeriodoDAO();
        Periodo pe = peDAO.periodoById(this.vvm_pe_id);
        ParamFixoDAO pfDAO = new ParamFixoDAO();
        ParamFixo pf = pfDAO.pfByTuId(pe.getPe_tu_id());
        CompraVendaMaquinaDAO cvmDAO;
        cvmDAO = new CompraVendaMaquinaDAO();
        qtCompra = cvmDAO.qtdeTransacao(this.vvm_pe_id, this.vvm_tm_id, "C");
        cvmDAO = new CompraVendaMaquinaDAO();
        qtVenda = cvmDAO.qtdeTransacao(this.vvm_pe_id, this.vvm_tm_id, "V");
        if(qtCompra > qtVenda){
            this.vvm_pcVariacao = pf.getPf_pcVarMaquinas();
        }
        if(qtCompra < qtVenda){
            this.vvm_pcVariacao = pf.getPf_pcVarMaquinas() * (-1);
        }
        VariacaoValorMaquinaDAO vvmDAO = new VariacaoValorMaquinaDAO();
        vvmDAO.atualizar(this);
    }

/*    public static void main (String args[]) throws JogosDAOException{
        VariacaoValorMaquinaDAO vvmDAO = new VariacaoValorMaquinaDAO();
        VariacaoValorMaquina vvm = vvmDAO.VariacaoByPeTmId(28, 1);
        vvm.determinarVariacao();
        System.out.println(vvm.vvm_pcVariacao);

    }*/

}
