/*
 * Bean para comunicação com as Páginas JSF
 * and open the template in the editor.
 */
package controller;

import dao.EmpresaPeriodoDAO;

import dao.JogadorAtualDAO;
import dao.JogosDAOException;
import entidades.Empresa;
import entidades.EmpresaPeriodo;
import entidades.JogadorAtual;
import util.ConversaoTela;

/**
 *
 * @author Doglei
 */
public class JogadorController {

    private String logado;
    private String mensagem;
    private String coordenador;
    private String aluno;
    private JogadorAtual jogador = new JogadorAtual();

    /**
     *
     * @return
     */
    public String getAluno() {
        aluno = "";
        if ("none".equals(logado)) {
            // está logado como administrador..
            if ("admin".equals(jogador.getUs_login())) {
                aluno = "none";
            } else {
                aluno = "";
            }
        }

        return aluno;
    }

    /**
     *
     * @param aluno
     */
    public void setAluno(String aluno) {
        this.aluno = aluno;
    }

    /**
     *
     * @return
     */
    public String getCoordenador() {
        coordenador = "none";
        if ("none".equals(this.getLogado())) {
            // está logado como administrador..
            if (!("admin".equals(jogador.getUs_login()))) {
                coordenador = "none";
            } else {
                coordenador = "";
            }
        }

        return coordenador;
    }

    /**
     *
     * @param coordenador
     */
    public void setCoordenador(String coordenador) {
        this.coordenador = coordenador;
    }

    /**
     *
     * @return
     */
    public String getLogado() {
        if ((jogador != null) && (jogador.getUs_logado())) {
            logado = "none";
        } else {
            logado = "";
        }

        return logado;
    }

    /**
     *
     * @param jgc
     */
    public void setJogadorAtual(JogadorController jgc) {
        if (jgc != null) {
            ConversaoTela.setSessionAttribute("jogadorView", jgc);
        }
    }

    /**
     *
     * @return
     */
    public JogadorController getJogadorAtual() {

        Object jogadorObj = ConversaoTela.getSessionAttribute("jogadorView");

        if ((jogadorObj != null) && (jogadorObj instanceof JogadorController)) {
            return (JogadorController) jogadorObj;
        } else {
            JogadorController jgc = new JogadorController();
            ConversaoTela.setSessionAttribute("jogadorView", jgc);
            return jgc;
        }
    }

    /**
     *
     * @return
     */
    public JogadorAtual getJogador() {
        return jogador;
    }

    /**
     *
     * @param jogador
     */
    public void setJogador(JogadorAtual jogador) {
        this.jogador = jogador;
    }

    /**
     *
     * @return
     */
    public String getMensagem() {
        if (jogador.getUs_logado()) {
            setMensagem("Você está logado como " + jogador.getUs_login());
        } else {
            setMensagem("Você não está logado no sistema.");
        }

        return mensagem;
    }

    /**
     *
     * @param mensagem
     */
    public void setMensagem(String mensagem) {
        this.mensagem = mensagem;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public String validarLogin() throws JogosDAOException {
        JogadorAtualDAO idao = new JogadorAtualDAO();

        return idao.validar(this.getJogador());
        //return "c4_form";
    }

    /**
     *
     * @return
     */
    public String cadastrarLogin() {
        return "formGerente";
    }

    /**
     *
     * @return
     */
    public String sairLogin() {
        jogador = new JogadorAtual();
        return "welcomeJSF";
    }

    /**
     *
     * @param jogador
     * @return
     * @throws JogosDAOException
     */
    public JogadorController altSessao(JogadorController jogador) throws JogosDAOException {
        EmpresaPeriodoDAO emp = new EmpresaPeriodoDAO();
        EmpresaPeriodo e = new EmpresaPeriodo();
        // if(jogador.getJogador().getUs_eCoordenador() != 1)//aluno
        if ((jogador.getJogador().getUs_empresa() > 0) && (jogador.getJogador().getUs_idPeriodo() > 0)) {
            e = emp.listaByEmpPer(jogador.getJogador().getUs_empresa(), jogador.getJogador().getUs_idPeriodo());
        }
        // else//está acessa da tela de coordenador
        //   e = emp.listaByEmpTurmaAtiv(jogador.getJogador().getUs_empresa(), jogador.getJogador().getUs_idTurma());

        jogador.getJogador().setUs_empresa_periodo(e.getEm_id());
        return jogador;
    }
}
