/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.PreparedStatement;
import entidades.Coordenador;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author rafael
 */
public class CoordenadorDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public CoordenadorDAO() throws JogosDAOException {
        try {
            this.conn = (Connection) ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param chave
     * @return
     */
    public String geraCod(int chave) {
        String cod = "A"+chave;
        return cod;
    }

    /**
     *
     * @param co
     * @throws JogosDAOException
     */
    public void salvar(Coordenador co) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;

        if (co == null) {
            throw new JogosDAOException("Erro ao gravar o Coordenador - CoordenadorDAO(salvar)");
        }

        try {
            String SQL = "insert into  coordenador (co_us_id, co_chave_acesso)  "
                    + "values (?,?)";
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement(SQL);
            ps.setInt(1, co.getCo_us_id());
            ps.setString(2, geraCod(co.getCo_us_id()));
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados Coordenador - CoordenadorDAO(salvar) " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    /**
     *
     * @param us_id
     * @return
     * @throws JogosDAOException
     */
    public Coordenador listaByLogin(int us_id) throws JogosDAOException {

        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select co_id, co_chave_acesso, co_us_id from coordenador"
                    + " where co_us_id = ? ");
            ps.setInt(1, us_id);

            rs = ps.executeQuery();
            Coordenador obj = new Coordenador();

            if (rs.next()) {
                obj.setCo_id(rs.getInt("co_id"));
                obj.setCo_us_id(rs.getInt("co_us_id"));
                obj.setCo_chave_acesso(rs.getString("co_chave_acesso"));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }
     public Coordenador listaByTurma(int tu_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select co_id, co_chave_acesso, co_us_id from coordenador"
                    + " where co_id in (select tu_co_id from turma where tu_id  = ?) ");
            ps.setInt(1, tu_id);

            rs = ps.executeQuery();
            Coordenador obj = new Coordenador();

            if (rs.next()) {
                obj.setCo_id(rs.getInt("co_id"));
                obj.setCo_chave_acesso(rs.getString("co_chave_acesso"));
                obj.setCo_us_id(rs.getInt("co_us_id"));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List<Coordenador> listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select c.co_id, u.us_noUsuario from usuario u join coordenador c on c.co_us_id = u.us_id order by 2");

            rs = ps.executeQuery();
            Coordenador obj;
            List<Coordenador> lista = new ArrayList<Coordenador>();
            while (rs.next()) {
                obj = new Coordenador();
                obj.setCo_id(rs.getInt("co_id"));
                obj.setNomeCoordenador(rs.getString("us_noUsuario"));
                lista.add(obj);

            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }
    /**
     *
     * @param chaveAcesso
     * @return
     * @throws JogosDAOException
     */
    public Coordenador listaByCodAcesso(String chaveAcesso) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select c.co_id, u.us_noUsuario from usuario u join coordenador c on c.co_us_id = u.us_id where" +
                    " co_chave_acesso = '"+chaveAcesso+"'");

            rs = ps.executeQuery();
            Coordenador obj = null;
            List<Coordenador> lista = new ArrayList<Coordenador>();
            if(rs.next()) {
                obj = new Coordenador();
                obj.setCo_id(rs.getInt("co_id"));
                obj.setNomeCoordenador(rs.getString("us_noUsuario"));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
