/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

//import classView.TotalEmprestimoEmpresa;
import entidades.Emprestimo;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import util.ConexaoFactory;

/**
 *
 * @author rafael
 */
public class EmprestimoDAO {

    private Connection conn;
    private String campo_sql = " ep_em_id, ep_tcm_id, ep_vlMaxEmp, ep_vlEmprestimo ";
    private String table = " emprestimo ";
    private String tbl_id = " ep_id ";

    /**
     *
     * @throws JogosDAOException
     */
    public EmprestimoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(Emprestimo obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (obj == null) {
            throw new JogosDAOException("O objeto utilizado não pode ser nulo.");
        }

            String SQL = "insert into "+table+" (ep_em_id, ep_tcm_id, ep_vlMaxEmp, ep_vlEmprestimo) "
                    + "values (?, ?, ?, ?)";
            conne = this.conn;
        try {
            int i = 1;
            ps = conne.prepareStatement(SQL);

            ps.setInt(i++, obj.getEp_em_id());
            ps.setInt(i++, obj.getEp_tcm_id());
            ps.setDouble(i++, obj.getEp_vlMaxEmp());
            ps.setDouble(i++, obj.getEp_vlEmprestimo());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(Emprestimo obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete." + obj.toString());
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from emprestimo where ep_id=?");
            ps.setInt(1, obj.getEp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(Emprestimo obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update emprestimo set "
                    + "ep_em_id = ?, "
                    + "ep_tcm_id = ?, "
                    + "ep_vlEmprestimo = ?, "
                    + "ep_vlMaxEmp = ? "
                    + "where ep_id = ?";
            conne = this.conn;
            int i = 1;
            ps = conne.prepareStatement(SQL);
            ps.setInt(i++, obj.getEp_em_id());
            ps.setInt(i++, obj.getEp_tcm_id());
            ps.setDouble(i++, obj.getEp_vlEmprestimo());
            ps.setDouble(i++, obj.getEp_vlMaxEmp());
            ps.setInt(i++, obj.getEp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ep_id, ep_em_id, ep_tcm_id, ep_vlMaxEmp, ep_vlEmprestimo from emprestimo");
            rs = ps.executeQuery();
            List<Emprestimo> lista = new ArrayList<Emprestimo>();
            while (rs.next()) {
                Emprestimo obj = new Emprestimo();
                obj.setEp_id(rs.getInt(1));
                obj.setEp_em_id(rs.getInt(2));
                obj.setEp_tcm_id(rs.getInt(3));
                obj.setEp_vlMaxEmp(rs.getDouble(4));
                obj.setEp_vlEmprestimo(rs.getDouble(5));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ep_id, ep_em_id, ep_tcm_id, ep_vlMaxEmp, ep_vlEmprestimo from emprestimo where ep_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Emprestimo> lista = new ArrayList<Emprestimo>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            Emprestimo obj;
            while (rs.next()) {
                obj = new Emprestimo();
                obj.setEp_id(rs.getInt(1));
                obj.setEp_em_id(rs.getInt(2));
                obj.setEp_tcm_id(rs.getInt(3));
                obj.setEp_vlMaxEmp(rs.getDouble(4));
                obj.setEp_vlEmprestimo(rs.getDouble(5));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public Emprestimo getByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection connei = null;
        ResultSet rs = null;
        try {
            connei = this.conn;
            String sql = "select " + tbl_id + " , " + campo_sql + " from " + table + " where ep_em_id = ?";
            
            ps = connei.prepareStatement(sql);
            ps.setInt(1, em_id);
            rs = ps.executeQuery();

            Emprestimo obj = new Emprestimo();
            
            if (rs.next()) {                
                obj.setEp_id(rs.getInt(1));
                obj.setEp_em_id(rs.getInt(2));
                obj.setEp_tcm_id(rs.getInt(3));
                obj.setEp_vlMaxEmp(rs.getDouble(4));
                obj.setEp_vlEmprestimo(rs.getDouble(5));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(connei, ps, rs);
        }
    }

     
    /**
     *
     * @param empresa
     * @return
     * @throws SQLException
     */
   /* public List getRelTipoEmprestimo(int empresa) throws SQLException {
        String sql =
                " select sum(t.esp_vlEmprestimo) as vlEmprestimo, "
                + "sum(t.esp_vlAmortizacao) as vlAmortizacao, "
                + " sum(t.esp_vlJuros) as vlJuros, "
                + "sum(t.esp_vlSaldoDevedor) as vlSaldoDevedor, p.pe_noPeriodo, t.tcm_nome from periodo p "
                + " join (select a.esp_vlEmprestimo, a.esp_vlAmortizacao, "
                + "a.esp_vlJuros, a.esp_vlSaldoDevedor, t.tcm_nome, em.em_pe_id from amortizacao a "
                + " join tipocompramp t on t.tcm_id = a.esp_tcm_id "
                + "join empresa_periodo em on em.em_id = a.esp_em_id where em.em_e_id = " + empresa + ") t on p.pe_id = t.em_pe_id "
                + "group by p.pe_noPeriodo ";
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;

        conne = this.conn;
        ps = conne.prepareStatement(sql);
        rs = ps.executeQuery();
        List<TotalEmprestimoEmpresa> lista = new ArrayList<TotalEmprestimoEmpresa>();

        if (rs == null) {
            try {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com a empresa: " + empresa);
            } catch (JogosDAOException ex) {
                Logger.getLogger(EmprestimoDAO.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        TotalEmprestimoEmpresa obj;
        int i = 1;
        while (rs.next()) {
            obj = new TotalEmprestimoEmpresa(0.0, 0.0, 0.0, 0.0, "", "");
            i = 1;
            obj.setVlEmprestimo(rs.getDouble(i++));
            obj.setVlAmortizacao(rs.getDouble(i++));
            obj.setVlJuros(rs.getDouble(i++));
            obj.setVlSaldoDevedor(rs.getDouble(i++));
            obj.setPe_noPeriodo(rs.getString(i++));
            obj.setTcm_nome(rs.getString(i++));
            lista.add(obj);
        }
        return lista;
    }*/

    /**
     *
     * @return
     */
    public Double getvlMaxEmpretimo(){
        return 12.89;
    }
}
