/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

/**
 *
 * @author rafael
 */
import entidades.Estoquemp;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author rafael
 */
public class EstoquempDAO{

    private Connection conn;
    /**
     *
     */
    public String campos_sql = " es_em_id, es_vlConsMPA, es_vlConsMPB, "
            + "es_vlCompEspMPA, es_vlCompEspMPB, es_vlCompProgMPA, es_vlCompProgMPB ";
    //public String tbl_id = " es_id ";

    /**
     *
     * @throws JogosDAOException
     */
    public EstoquempDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(Estoquemp obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (obj == null) {
            throw new JogosDAOException("O objeto utilizado não pode ser nulo.");
        }

        try {
           
            String SQL = "insert into estoquemp (" + campos_sql + ") "
                    + "values (?,?,?,?,?,?,?,?)";

            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, obj.getEs_em_id());
            ps.setDouble(i++, obj.getEs_vlConsMPA());
            ps.setDouble(i++, obj.getEs_vlConsMPB());
            ps.setDouble(i++, obj.getEs_vlCompEspMPA());
            ps.setDouble(i++, obj.getEs_vlCompEspMPB());
            ps.setDouble(i++, obj.getEs_vlCompProgMPA());
            ps.setDouble(i++, obj.getEs_vlCompProgMPB());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(Estoquemp obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete." + obj.toString());
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from estoquemp where es_id=?");
            ps.setInt(1, obj.getEs_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(Estoquemp obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update estoquemp set "
                    + " es_em_id = ?, "
                    + " es_vlConsMPA = ?, "
                    + " es_vlConsMPB = ?, "
                    + " es_vlCompEspMPA = ?, "
                    + " es_vlCompEspMPB = ?, "
                    + " es_vlCompProgMPA = ?, "
                    + " es_vlCompProgMPB = ?"
                    + " where es_id = ?";
            conne = this.conn;
            System.out.println(SQL);
            ps = conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, obj.getEs_em_id());
            ps.setDouble(i++, obj.getEs_vlConsMPA());
            ps.setDouble(i++, obj.getEs_vlConsMPB());
            ps.setDouble(i++, obj.getEs_vlCompEspMPA());
            ps.setDouble(i++, obj.getEs_vlCompEspMPB());
            ps.setDouble(i++, obj.getEs_vlCompProgMPA());
            ps.setDouble(i++, obj.getEs_vlCompProgMPB());
            ps.setInt(i++, obj.getEs_id());//o id fica por ultimo
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conn, ps, null);
        }
    }


    
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select es_id, " + campos_sql + " from estoquemp");
            rs = ps.executeQuery();
            List<Estoquemp> lista = new ArrayList<Estoquemp>();
            int i;
            while (rs.next()) {
                Estoquemp obj = new Estoquemp();
                i = 1;
                obj.setEs_id(rs.getInt(i++));
                obj.setEs_em_id(rs.getInt(i++));
                obj.setEs_vlConsMPA(rs.getDouble(i++));
                obj.setEs_vlConsMPB(rs.getDouble(i++));
                obj.setEs_vlCompEspMPA(rs.getDouble(i++));
                obj.setEs_vlCompEspMPB(rs.getDouble(i++));
                obj.setEs_vlCompProgMPA(rs.getDouble(i++));
                obj.setEs_vlCompProgMPB(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public Estoquemp getByEmPr(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;

        try {
            conne = this.conn;
            ps = conne.prepareStatement("select es_id, es_em_id, es_vlConsMPA, es_vlConsMPB, es_vlCompEspMPA, "
                    + "es_vlCompEspMPB, es_vlCompProgMPA, es_vlCompProgMPB from estoquemp where es_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            //List<Estoquemp> lista = new ArrayList<Estoquemp>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }
            Estoquemp estoquemp = new Estoquemp();
            while (rs.next()) {
                estoquemp.setEs_id(rs.getInt(1));
                estoquemp.setEs_em_id(rs.getInt(2));
                estoquemp.setEs_vlConsMPA(rs.getDouble(3));
                estoquemp.setEs_vlConsMPB(rs.getDouble(4));
                estoquemp.setEs_vlCompEspMPA(rs.getDouble(5));
                estoquemp.setEs_vlCompEspMPB(rs.getDouble(6));
                estoquemp.setEs_vlCompProgMPA(rs.getDouble(7));
                estoquemp.setEs_vlCompProgMPB(rs.getDouble(8));
                estoquemp.calcConsumoMP();
            }
            return estoquemp;
            //System.out.println(estoquemp.toString());
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /*
     
    public Estoquemp listaById(int id) throws JogosDAOException {
    PreparedStatement ps = null;
    Connection conne = null;
    ResultSet rs = null;
    try {
    conne = this.conn;
    ps = conne.prepareStatement("select es_id, es_em_id, es_vlConsMPA, es_vlConsMPB, es_vlCompEspMPA, es_vlCompEspMPB,"
    + " es_vlCompProgMPA, "
    + " es_vlCompProgMPB from estoquemp where es_em_id = ?");
    ps.setInt(1, id);
    rs = ps.executeQuery();
    List<Estoquemp> lista = new ArrayList<Estoquemp>();

    if (!rs.next()) {
    throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
    }

    Estoquemp estoquemp = new Estoquemp(0, 0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
    while (rs.next()) {
    estoquemp.setEs_id(rs.getInt(1));
    estoquemp.setEs_em_id(rs.getInt(2));
    estoquemp.setEs_vlConsMPA(rs.getDouble(3));
    estoquemp.setEs_vlConsMPB(rs.getDouble(4));
    estoquemp.setEs_vlCompEspMPA(rs.getDouble(5));
    estoquemp.setEs_vlCompEspMPB(rs.getDouble(6));
    estoquemp.setEs_vlCompProgMPA(rs.getDouble(7));
    estoquemp.setEs_vlCompProgMPB(rs.getDouble(8));
    }
    System.out.println(estoquemp.toString());
    return estoquemp;
    } catch (SQLException sqle) {
    throw new JogosDAOException(sqle);
    } finally {
    ConexaoFactory.closeConnection(conne, ps, rs);
    }
    }*/
}
