/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package dao;

/**
 *
 * @author rafael
 */
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;
import entidades.FinMaquinas;
/**
 *
 * @author rafael
 */
public class FinMaquinasDAO {

    private Connection conn;
    /**
     *
     */
    public String campos_sql = "  fm_em_id, "+
                               "  fm_vlFinanciamento, "+
                               "  fm_vlAmortizacao, "+
                               "  fm_vlJuros, "+
                               "  fm_vlSaldoDevedor ";
    /**
     *
     */
    public String tbl_id = "fm_id";
    /**
     *
     */
    public String tabela = "finmaquinas";


    /**
     *
     * @throws JogosDAOException
     */
    public FinMaquinasDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(FinMaquinas obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (obj == null) {
            throw new JogosDAOException("O objeto utilizado não pode ser nulo.");
        }

        try {
            String temp = "?";
            for(int i=1;i<7;i++)
              temp += ", ?";

            String SQL = "insert into "+tabela+" ("+campos_sql+") "
                    + "values ("+temp+")";

            conne = this.conn;
            int i=1;
            ps = conne.prepareStatement(SQL);            
            ps.setInt(i++, obj.getFm_em_id());
            ps.setDouble(i++, obj.getFm_vlFinanciamento());
            ps.setDouble(i++, obj.getFm_vlAmortizacao());
            ps.setDouble(i++, obj.getFm_vlJuros());
            ps.setDouble(i++, obj.getFm_vlSaldoDevedor());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(FinMaquinas obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete."+obj.toString());
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from "+tabela+" where "+tbl_id+"=?");
            ps.setInt(1, obj.getFm_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(FinMaquinas obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update "+tabela+" set "
                            +" fm_em_id = ?, "
                            +" fm_vlFinanciamento = ?, "
                            +" fm_vlAmortizacao = ?, "
                            +" fm_vlJuros = ?, "
                            +" fm_vlSaldoDevedor = ? "
                            + "where "+tbl_id+" = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i=1;
            ps.setInt(i++, obj.getFm_em_id());
            ps.setDouble(i++, obj.getFm_vlFinanciamento());
            ps.setDouble(i++, obj.getFm_vlAmortizacao());
            ps.setDouble(i++, obj.getFm_vlJuros());
            ps.setDouble(i++, obj.getFm_vlSaldoDevedor());
            ps.setInt(i++, obj.getFm_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select "+tbl_id+ ", " +campos_sql+" from "+tabela);
            rs = ps.executeQuery();
            List<FinMaquinas> lista = new ArrayList<FinMaquinas>();
            while (rs.next()) {
                FinMaquinas obj = new FinMaquinas(0, 0, 0.0, 0.0, 0.0, 0.0);
                obj.setFm_id(rs.getInt(1));
                obj.setFm_em_id(rs.getInt(2));
                obj.setFm_vlFinanciamento(rs.getDouble(3));
                obj.setFm_vlAmortizacao(rs.getDouble(4));
                obj.setFm_vlJuros(rs.getDouble(5));
                obj.setFm_vlSaldoDevedor(rs.getDouble(6));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select "+tbl_id+ ", " +campos_sql+" from "+tabela+" where "+tbl_id+" = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<FinMaquinas> lista = new ArrayList<FinMaquinas>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            int i=1;
            while (rs.next()) {
                FinMaquinas obj = new FinMaquinas(0, 0, 0.0,  0.0, 0.0, 0.0);
                obj.setFm_id(rs.getInt(i++));
                obj.setFm_em_id(rs.getInt(i++));
                obj.setFm_vlFinanciamento(rs.getDouble(i++));
                obj.setFm_vlAmortizacao(rs.getDouble(i++));
                obj.setFm_vlJuros(rs.getDouble(i++));
                obj.setFm_vlSaldoDevedor(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

}
