/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.CompraMP;
import entidades.Estoquemp;
import entidades.Fluxocaixa;
import java.sql.Connection;
import java.sql.PreparedStatement;

import entidades.FolhaDecisoes;
import entidades.Produtividade;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author rafael
 */
public class FolhaDecisoesDAO {

    /**
     *
     */
    public Connection conn;
    /**
     *
     */
    public String campos_sql = " fd_nrAdmitidos, "
            + " fd_nrDemitidos ";
    /**
     *
     */
    public String tbl_id = "fd_id";
    /**
     *
     */
    public String tabela = "folha_decisoes";

    /**
     *
     * @throws JogosDAOException
     */
    public FolhaDecisoesDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param fd
     * @throws JogosDAOException
     */
    public void salvar(FolhaDecisoes fd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (fd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into folha_decisoes (fd_em_id, " +
                    "fd_nrAdmitidos, " +
                    "fd_nrDemitidos, " +
                    "fd_nrSalario, " +
                    "fd_pcTreinamento, " +
                    "fd_pcParticipacao, " +
                    "fd_vlCompProgMPA,"
                    + "fd_vlCompProgMPB, " +
                    "fd_nrPzPgtoMP, " +
                    "fd_pcNivelAtividade, " +
                    "fd_nrCompMaqA, fd_nrCompMaqB,"
                    + "fd_nrCompMaqG, fd_nrVendMaqA, fd_nrVendMaqB, fd_nrVendMaqG, fd_vlEmprestimo, "
                    + "fd_nrTpEmprestimo, fd_vlAplicacao, fd_pcJurosVdPz, fd_vlDiversos)"
                    + " values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, fd.getFd_em_id());
            ps.setInt(2, fd.getFd_nrAdmitidos());
            ps.setInt(3, fd.getFd_nrDemitidos());
            ps.setDouble(4, fd.getFd_nrSalario());
            ps.setDouble(5, fd.getFd_pcTreinamento());
            ps.setDouble(6, fd.getFd_pcParticipacao());
            ps.setDouble(7, fd.getFd_vlCompProgMPA());
            ps.setDouble(8, fd.getFd_vlCompProgMPB());
            ps.setInt(9, fd.getFd_nrPzPgtoMP());
            ps.setDouble(10, fd.getFd_pcNivelAtividade());
            ps.setInt(11, fd.getFd_nrCompMaqA());
            ps.setInt(12, fd.getFd_nrCompMaqB());
            ps.setInt(13, fd.getFd_nrCompMaqG());
            ps.setInt(14, fd.getFd_nrVendMaqA());
            ps.setInt(15, fd.getFd_nrVendMaqB());
            ps.setInt(16, fd.getFd_nrVendMaqG());
            ps.setDouble(17, fd.getFd_vlEmprestimo());
            ps.setInt(18, fd.getFd_nrTpEmprestimo());
            ps.setDouble(19, fd.getFd_vlAplicacao());
            ps.setDouble(20, fd.getFd_pcJurosVdPz());
            ps.setDouble(21, fd.getFd_vlDiversos());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param fd
     * @throws JogosDAOException
     */
    public void excluir(FolhaDecisoes fd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (fd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from folha_decisoes where fd_id=?");
            ps.setInt(1, fd.getFd_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public List getFolhaFd(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        ResultSet rs = null;
        try {
            //conne = (Connection) ConexaoFactory.getConnection();
            String SQL = "select " + tbl_id + ", fd_nrAdmitidos, fd_nrDemitidos from folha_decisoes where fd_em_id = ? ";
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, em_id);
            rs = ps.executeQuery();
            List<FolhaDecisoes> lista = new ArrayList<FolhaDecisoes>();

            while (rs.next()) {
                FolhaDecisoes obj = new FolhaDecisoes(0, 0, 0, 0, 0,0.0, 0.0, 0, 0, 0, 0.0, 0.0, 0.0, 0, 0, 0, 0, 0, 0, 0.0, 0, 0.0, 0.0, 0.0);
                obj.setFd_id(rs.getInt(1));
                obj.setFd_nrAdmitidos(rs.getInt(2));
                obj.setFd_nrDemitidos(rs.getInt(3));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection((java.sql.Connection) conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public FolhaDecisoes getFolhaFdObj(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        ResultSet rs = null;
        try {
            //conne = (Connection) ConexaoFactory.getConnection();
            String sql = "select " + tbl_id + ", fd_nrAdmitidos, fd_nrDemitidos, fd_nrSalario, fd_pcTreinamento, " +
                    "fd_pcParticipacao, " +
                    "fd_vlCompProgMPA, " +
                    "fd_vlCompProgMPB, " +
                    "fd_nrPzPgtoMP, " +
                    "fd_pcNivelAtividade, " +
                    "fd_pcProducaoExtra, fd_pcProdutividade, " +
                    "fd_nrCompMaqA, " +
                    "fd_nrCompMaqB, " +
                    "fd_nrCompMaqG, " +
                    "fd_nrVendMaqA, " +
                    "fd_nrVendMaqB, " +
                    "fd_nrVendMaqG, " +
                    "fd_vlEmprestimo, " +
                    "fd_nrTpEmprestimo, " +
                    "fd_vlAplicacao, " +
                    "fd_pcJurosVdPz, " +
                    "fd_vlDiversos from folha_decisoes where fd_em_id = " + em_id;
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            FolhaDecisoes obj = null;
            while (rs.next()) {
                obj = new FolhaDecisoes(0, 0, 0, 0, 0, 0.0,0.0, 0, 0, 0, 0.0, 0.0, 0.0, 0, 0, 0, 0, 0, 0, 0.0, 0, 0.0, 0.0, 0.0);
                obj.setFd_id(rs.getInt(1));
                obj.setFd_nrAdmitidos(rs.getInt(2));
                obj.setFd_nrDemitidos(rs.getInt(3));
                obj.setFd_nrSalario(rs.getInt(4));
                obj.setFd_pcTreinamento(rs.getDouble(5));
                obj.setFd_pcParticipacao(rs.getDouble(6));
                obj.setFd_vlCompProgMPA(rs.getDouble(7));
                obj.setFd_vlCompProgMPB(rs.getDouble(8));
                obj.setFd_nrPzPgtoMP(rs.getInt(9));
                obj.setFd_pcNivelAtividade(rs.getDouble(10));
                obj.setFd_pcProducaoExtra(rs.getDouble(11));
                obj.setFd_pcProdutividade(rs.getDouble(12));
                obj.setFd_nrCompMaqA(rs.getInt(13));
                obj.setFd_nrCompMaqB(rs.getInt(14));
                obj.setFd_nrCompMaqG(rs.getInt(15));
                obj.setFd_nrVendMaqA(rs.getInt(16));
                obj.setFd_nrVendMaqB(rs.getInt(17));
                obj.setFd_nrVendMaqG(rs.getInt(18));
                obj.setFd_vlEmprestimo(rs.getDouble(19));
                obj.setFd_nrTpEmprestimo(rs.getInt(20));
                obj.setFd_vlAplicacao(rs.getDouble(21));
                obj.setFd_pcJurosVdPz(rs.getDouble(22));
                obj.setFd_vlDiversos(rs.getDouble(23));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection((java.sql.Connection) conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public FolhaDecisoes listaByEmpresaPeriodoVendas(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select fd_id, " +
                    "fd_em_id, " +
                    "fd_nrAdmitidos, " +
                    "fd_nrDemitidos, " +
                    "fd_nrSalario, " +
                    "fd_pcTreinamento, " +
                    "fd_pcParticipacao, " +
                    "fd_vlCompProgMPA,"
                    + "fd_vlCompProgMPB, " +
                    "fd_nrPzPgtoMP, " +
                    "fd_pcNivelAtividade, " +
                    "fd_pcProducaoExtra, " +
                    "fd_nrCompMaqA," +
                    "fd_nrCompMaqB,"
                    + "fd_nrCompMaqG, " +
                    "fd_nrVendMaqA, " +
                    "fd_nrVendMaqB, fd_nrVendMaqG, " +
                    "fd_vlEmprestimo, "
                    + "fd_nrTpEmprestimo, " +
                    "fd_vlAplicacao, " +
                    "fd_pcJurosVdPz, fd_vlDiversos from ejogos.folha_decisoes where fd_em_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
          //  List<FolhaDecisoes> lista = new ArrayList<FolhaDecisoes>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
                FolhaDecisoes fd = new FolhaDecisoes();
            while (rs.next()) {
                fd.setFd_id(rs.getInt(1));
                fd.setFd_em_id(rs.getInt(2));
                fd.setFd_nrAdmitidos(rs.getInt(3));
                fd.setFd_nrDemitidos(rs.getInt(4));
                fd.setFd_nrSalario(rs.getInt(5));
                fd.setFd_pcTreinamento(rs.getDouble(6));
                fd.setFd_pcParticipacao(rs.getDouble(7));
                fd.setFd_vlCompProgMPA(rs.getDouble(8));
                fd.setFd_vlCompProgMPB(rs.getDouble(9));
                fd.setFd_nrPzPgtoMP(rs.getInt(10));
                fd.setFd_pcNivelAtividade(rs.getDouble(11));
                fd.setFd_pcProducaoExtra(rs.getDouble(12));
                fd.setFd_nrCompMaqA(rs.getInt(13));
                fd.setFd_nrCompMaqB(rs.getInt(14));
                fd.setFd_nrCompMaqG(rs.getInt(15));
                fd.setFd_nrVendMaqA(rs.getInt(16));
                fd.setFd_nrVendMaqB(rs.getInt(17));
                fd.setFd_nrVendMaqG(rs.getInt(18));
                fd.setFd_vlEmprestimo(rs.getDouble(19));
                fd.setFd_nrTpEmprestimo(rs.getInt(20));
                fd.setFd_vlAplicacao(rs.getDouble(21));
                fd.setFd_pcJurosVdPz(rs.getDouble(22));
                fd.setFd_vlDiversos(rs.getDouble(23));
               // lista.add(fd);
            }
            return fd;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(FolhaDecisoes obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update " + tabela + " set "
                    + " fd_nrAdmitidos = ?, "
                    + " fd_nrDemitidos = ?, "
                    + " fd_nrSalario = ?, "
                    + " fd_pcTreinamento = ?, "
                    + " fd_pcParticipacao = ?, "
                    + " fd_vlCompProgMPA = ?, "
                    + " fd_vlCompProgMPB = ?, "
                    + " fd_nrPzPgtoMP = ?, "
                    + " fd_pcNivelAtividade = ?, "
                    + " fd_pcProducaoExtra = ?, "
                    + " fd_pcProdutividade = ?, "
                    + " fd_nrCompMaqA = ?, "
                    + " fd_nrCompMaqB = ?, "
                    + " fd_nrCompMaqG = ?, "
                    + " fd_nrVendMaqA = ?, "
                    + " fd_nrVendMaqB = ?, "
                    + " fd_nrVendMaqG = ?, "
                    + " fd_vlEmprestimo = ?, "
                    + " fd_nrTpEmprestimo = ?, "
                    + " fd_vlAplicacao = ?, "
                    + " fd_pcJurosVdPz = ?, "
                    + " fd_vlDiversos = ? "
                    + " where " + tbl_id + "= ?";

            int i = 1;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(i++, obj.getFd_nrAdmitidos());
            ps.setDouble(i++, obj.getFd_nrDemitidos());
            ps.setDouble(i++, obj.getFd_nrSalario());
            ps.setDouble(i++, obj.getFd_pcTreinamento());
            ps.setDouble(i++, obj.getFd_pcParticipacao());
            ps.setDouble(i++, obj.getFd_vlCompProgMPA());
            ps.setDouble(i++, obj.getFd_vlCompProgMPB());
            ps.setInt(i++, obj.getFd_nrPzPgtoMP());
            ps.setDouble(i++, obj.getFd_pcNivelAtividade());
            ps.setDouble(i++, obj.getFd_pcProducaoExtra());
            ps.setDouble(i++, obj.getFd_pcProdutividade());
            ps.setInt(i++, obj.getFd_nrCompMaqA());
            ps.setInt(i++, obj.getFd_nrCompMaqB());
            ps.setInt(i++, obj.getFd_nrCompMaqG());
            ps.setInt(i++, obj.getFd_nrVendMaqA());
            ps.setInt(i++, obj.getFd_nrVendMaqB());
            ps.setInt(i++, obj.getFd_nrVendMaqG());
            ps.setDouble(i++, obj.getFd_vlEmprestimo());
            ps.setInt(i++, obj.getFd_nrTpEmprestimo());
            ps.setDouble(i++, obj.getFd_vlAplicacao());
            ps.setDouble(i++, obj.getFd_pcJurosVdPz());
            ps.setDouble(i++, obj.getFd_vlDiversos());
            ps.setInt(i++, obj.getFd_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param pdt
     * @throws JogosDAOException
     */
    public void atualizarProdutividade(Produtividade pdt) throws JogosDAOException{
    PreparedStatement ps = null;
        Connection conne = null;
        if (pdt == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update folha_decisoes set "
                    + "fd_pcNivelAtividade = ?, "
                    + "fd_pcProducaoExtra = ?"
                    + "where fd_em_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(1, pdt.getPd_pcNivelAtividade());
            ps.setDouble(2, pdt.getPd_pcHoraExtra());
            ps.setInt(3, pdt.getPd_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
     
    /**
     *
     * @param cmp
     * @throws JogosDAOException
     */
    public void atualizarCompraMP(CompraMP cmp) throws JogosDAOException{
    PreparedStatement ps = null;
        Connection conne = null;
        if (cmp == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update folha_decisoes set "
                    + "fd_nrPzPgtoMP = ? "
                    + "where fd_em_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, cmp.getCmp_tcm_id());
            ps.setInt(2, cmp.getCmp_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param est
     * @throws JogosDAOException
     */
    public void atualizarEstoqueMP(Estoquemp est) throws JogosDAOException{
    PreparedStatement ps = null;
        Connection conne = null;
        if (est == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update folha_decisoes set "
                    + "fd_vlCompProgMPA = ?,"
                    + "fd_vlCompProgMPB = ?"
                    + "where fd_em_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(1, est.getEs_vlCompProgMPA());
            ps.setDouble(2, est.getEs_vlCompProgMPB());
            ps.setInt(3, est.getEs_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param fc
     * @throws JogosDAOException
     */
    public void atualizarRecebimento(Fluxocaixa fc) throws JogosDAOException{
    PreparedStatement ps = null;
        Connection conne = null;
        if (fc == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update folha_decisoes set "
                    + "fd_vlAplicacao = ?,"
                    + "fd_vlDiversos = ?"
                    + "where fd_em_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(1, fc.getFx_vlAplicacao());
            ps.setDouble(2, fc.getFx_vlDiversos());
            ps.setInt(3, fc.getFx_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param fd
     * @throws JogosDAOException
     */
    public void atualizarVendas(FolhaDecisoes fd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (fd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update folha_decisoes set "
                    + "fd_em_id = ?, "
                    + "fd_pcJurosVdPz = ?"
                    + "where fd_em_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, fd.getFd_em_id());
            ps.setDouble(2, fd.getFd_pcJurosVdPz());
            ps.setInt(3, fd.getFd_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
     
    /**
     *
     * @param fd
     * @throws JogosDAOException
     */
    public void atualizarMaquina(FolhaDecisoes fd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (fd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update folha_decisoes set "
                    + "fd_em_id = ?, "
                    + "fd_nrCompMaqA = ?,"
                    + "fd_nrCompMaqB = ?,"
                    + "fd_nrCompMaqC = ?,"
                    + "fd_nrVendMaqA = ?,"
                    + "fd_nrVendMaqC = ?,"
                    + "fd_nrVendMaqG = ?"
                    + "where fd_em_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, fd.getFd_em_id());
            ps.setDouble(2, fd.getFd_pcJurosVdPz());
            ps.setInt(3, fd.getFd_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaByEmpresaPeriodo(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " +
                    "fd_id, " +
                    "fd_em_id, " +
                    "fd_nrAdmitidos, " +
                    "fd_nrDemitidos, " +
                    "fd_nrSalario, " +
                    "fd_pcParticipacao, " +
                    "fd_vlCompProgMPA,"
                    + "fd_vlCompProgMPB, " +
                    "(select tcm_nome from tipocompramp where tcm_id =  fd_nrPzPgtoMP) as fd_nrPzPgtoMP, " +
                    "fd_pcNivelAtividade, " +
                    "fd_nrCompMaqA, " +
                    "fd_nrCompMaqB,"
                    + "fd_nrCompMaqG," +
                    " fd_nrVendMaqA, " +
                    "fd_nrVendMaqB, " +
                    "fd_nrVendMaqG, " +
                    "fd_vlEmprestimo, "
                    + "fd_nrTpEmprestimo, " +
                    "fd_vlAplicacao, fd_pcJurosVdPz," +
                    " fd_vlDiversos, fd_pcProducaoExtra" +
                    " from folha_decisoes where fd_em_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<FolhaDecisoes> lista = new ArrayList<FolhaDecisoes>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            while (rs.next()) {
                FolhaDecisoes fd = new FolhaDecisoes(0, 0, 0, 0, 0, 0.0,0.0, 0, 0, 0, 0.0, 0.0, 0.0, 0, 0, 0, 0, 0, 0, 0.0, 0, 0.0, 0.0, 0.0);
                fd.setFd_id(rs.getInt(1));
                fd.setFd_em_id(rs.getInt(2));
                fd.setFd_nrAdmitidos(rs.getInt(3));
                fd.setFd_nrDemitidos(rs.getInt(4));
                fd.setFd_nrSalario(rs.getInt(5));
                fd.setFd_pcParticipacao(rs.getDouble(6));
                fd.setFd_vlCompProgMPA(rs.getDouble(7));
                fd.setFd_vlCompProgMPB(rs.getDouble(8));
                fd.setFd_nrPzPgtoMPC4(rs.getString(9));
                fd.setFd_pcNivelAtividade(rs.getDouble(10));
                fd.setFd_nrCompMaqA(rs.getInt(11));
                fd.setFd_nrCompMaqB(rs.getInt(12));
                fd.setFd_nrCompMaqG(rs.getInt(13));
                fd.setFd_nrVendMaqA(rs.getInt(14));
                fd.setFd_nrVendMaqB(rs.getInt(15));
                fd.setFd_nrVendMaqG(rs.getInt(16));
                fd.setFd_vlEmprestimo(rs.getDouble(17));
                fd.setFd_nrTpEmprestimo(rs.getInt(18));
                fd.setFd_vlAplicacao(rs.getDouble(19));
                fd.setFd_pcJurosVdPz(rs.getDouble(20));
                fd.setFd_vlDiversos(rs.getDouble(21));
                fd.setFd_pcProducaoExtra(rs.getDouble(22));
                lista.add(fd);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List maquinasByEmpresaPeriodo(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select 'Compra' as maq_Coluna, fd_nrCompMaqA as maq_Alfa, "+
                    "fd_nrCompMaqB as maq_Beta, fd_nrCompMaqG as maq_Gama " +
                    " from ejogos.folha_decisoes where fd_em_id = ? union " +
                    " select 'Venda' as maq_Coluna, fd_nrVendMaqA as maq_Alfa, fd_nrVendMaqB as maq_Beta, "+
                    " fd_nrVendMaqG as maq_Gama "
                    + "from ejogos.folha_decisoes where fd_em_id = ? ");
            ps.setInt(1, id);
            ps.setInt(2, id);
            rs = ps.executeQuery();
            List<FolhaDecisoes> lista = new ArrayList<FolhaDecisoes>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            while (rs.next()) {
                FolhaDecisoes fd = new FolhaDecisoes(0, 0, 0, 0, 0, 0.0,0.0, 0, 0, 0, 0.0, 0.0, 0.0, 0, 0, 0, 0, 0, 0, 0.0, 0, 0.0, 0.0, 0.0);
                fd.setMaq_Coluna(rs.getString(1));
                fd.setMaq_Alfa(String.valueOf(rs.getInt(2)));
                fd.setMaq_Beta(String.valueOf(rs.getInt(3)));
                fd.setMaq_Gama(String.valueOf(rs.getInt(4)));
                lista.add(fd);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
