/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

/**
 *
 * @author rafael
 */
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;
import entidades.FolhaPagamento;

/**
 *
 * @author rafael
 */
public class FolhaPagamentoDAO {

    /**
     *
     */
    public Connection conn;
    /**
     *
     */
    public String campos_sqls =" fp_em_id, "
            + " fp_pcTreinamento, "
            + " fp_pcPartLucro, "
            + " fp_nrAdmitidos, "
            + " fp_nrDemitidos, "
            + " fp_vlSalarioBase ";
    public String campos_sql =" fp_em_id, "
            + " fp_pcTreinamento, "
            + " fp_pcPartLucro, "
            + " fp_nrAdmitidos, "
            + " fp_nrDemitidos, "
            + " fp_vlSalarioBase ";
    /**
     *
     */
    public String tbl_id = "fp_id";
    /**
     *
     */
    public String tabela = "folhapagamento";

    /**
     *
     * @throws JogosDAOException
     */
    public FolhaPagamentoDAO() throws JogosDAOException {
        try {
            this.conn = (Connection) ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(FolhaPagamento obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        System.out.println("metodo salvar..");
        if (obj == null) {
            throw new JogosDAOException("O objeto utilizado não pode ser nulo.");
        }

        try {
            String temp = "?";
            for (int i = 1; i < 8; i++) {
                temp += ", ?";
            }

            String SQL = "insert into " + tabela + " (" + campos_sql + ") "
                    + "values (" + temp + ")";
            
            int i=1;
            ps = conne.prepareStatement(SQL);            
            ps.setInt(i++, obj.getFp_em_id());
            ps.setDouble(i++, obj.getFp_pcTreinamento());
            ps.setDouble(i++, obj.getFp_pcPartLucro());
            ps.setInt(i++, obj.getFp_nrAdmitidos());
            ps.setInt(i++, obj.getFp_nrDemitidos());
            ps.setDouble(i++, obj.getFp_vlSalarioBase());

            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(FolhaPagamento obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete." + obj.toString());
        }

        try {
            
            ps = conne.prepareStatement("delete from " + tabela + " where " + tbl_id + "=?");
            ps.setInt(1, obj.getFp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(FolhaPagamento obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update " + tabela + " set "
                    + " fp_em_id = ?, "
                    + " fp_pcTreinamento = ?, "
                    + " fp_nrAdmitidos = ?, "
                    + " fp_nrDemitidos = ?, "
                    + " fp_vlSalarioBase = ?, "
                    + " fp_pcPartLucro = ? "
                    +" where "+tbl_id+"= ? ";
            
            int i=1;
            ps = conne.prepareStatement(SQL);
            ps.setInt(i++, obj.getFp_em_id());
            ps.setDouble(i++, obj.getFp_pcTreinamento());
            ps.setInt(i++, obj.getFp_nrAdmitidos());
            ps.setInt(i++, obj.getFp_nrDemitidos());
            ps.setDouble(i++, obj.getFp_vlSalarioBase());
            ps.setDouble(i++, obj.getFp_pcPartLucro());
            ps.setInt(i++, obj.getFp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public List getFolha(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        ResultSet rs = null;
        try {
            
            String sql = "select " +tbl_id+ ", " +campos_sqls + " from " + tabela +" where fp_em_id = "+em_id;
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            List<FolhaPagamento> lista = new ArrayList<FolhaPagamento>();
            int i;
            FolhaPagamento obj = null;
            while (rs.next()) {
                i=1;
                obj = new FolhaPagamento();
                obj.setFp_id(rs.getInt(i++));
                obj.setFp_em_id(rs.getInt(i++));
                obj.setFp_pcTreinamento(rs.getDouble(i++));
                obj.setFp_pcPartLucro(rs.getDouble(i++));
                obj.setFp_nrAdmitidos(rs.getInt(i++));
                obj.setFp_nrDemitidos(rs.getInt(i++));
                obj.setFp_vlSalarioBase(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
     
    /**
     *
     * @param ep_id
     * @return
     * @throws JogosDAOException
     */
    public FolhaPagamento getFolhaObj(int ep_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = this.conn;
        ResultSet rs = null;
        try {
            
            String sql = "select " +tbl_id+ ", " +campos_sqls + " from " + tabela +" where fp_em_id = "+ep_id;
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            
            int i;
            FolhaPagamento obj = new FolhaPagamento();
            while (rs.next()) {
                i=1;
                obj.setFp_id(rs.getInt(i++));
                obj.setFp_em_id(rs.getInt(i++));
                obj.setFp_pcTreinamento(rs.getDouble(i++));
                obj.setFp_pcPartLucro(rs.getDouble(i++));
                obj.setFp_nrAdmitidos(rs.getInt(i++));
                obj.setFp_nrDemitidos(rs.getInt(i++));
                obj.setFp_vlSalarioBase(rs.getDouble(i++));
                obj.rescisao();
                obj.participacao();
                //obj.calcHoraExtra();
            }
            
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = (Connection) ConexaoFactory.getConnection();
            ps = conne.prepareStatement("select " +tbl_id+ ", " +campos_sqls + " from " + tabela + " where " + tbl_id + " = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<FolhaPagamento> lista = new ArrayList<FolhaPagamento>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            int i;
            while (rs.next()) {
                FolhaPagamento obj = new FolhaPagamento(0, 0, 0.0, 0.0,0.0);
                i=1;
                obj.setFp_id(rs.getInt(i++));
                obj.setFp_em_id(rs.getInt(i++));
                obj.setFp_pcTreinamento(rs.getDouble(i++));
                obj.setFp_pcPartLucro(rs.getDouble(i++));
                obj.setFp_nrAdmitidos(rs.getInt(i++));
                obj.setFp_nrDemitidos(rs.getInt(i++));
                obj.setFp_vlSalarioBase(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

  
}
