/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Gerente;
import entidades.JogadorAtual;
import entidades.Turma;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class GerenteDAO  {

    private Connection conn;
    private Turma turma;

    /**
     *
     * @return
     */
    public Turma getTurma() {
        return turma;
    }


    /**
     *
     * @param turma
     */
    public void setTurma(Turma turma) {
        this.turma = turma;
    }

    /**
     *
     * @throws JogosDAOException
     */
    public GerenteDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param ger
     * @throws JogosDAOException
     */
    public void salvar(Gerente ger) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (ger == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into gerente (ge_tu_id, ge_se_id, ge_e_id, ge_nrMatric, ge_us_id) "
                    + "values (?, ?, ?, ?, ?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, ger.getGe_tu_id());
            ps.setInt(2, ger.getGe_se_id());
            ps.setInt(3, ger.getGe_e_id());
            ps.setString(4, ger.getGe_nrMatric());
            ps.setInt(5, ger.getGe_us_id());


            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados de Gerente GerenteDAO(salvar) " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @param ger
     * @throws JogosDAOException
     */
    public void excluir(Gerente ger) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (ger == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from gerente where ge_id=?");
            ps.setInt(1, ger.getGe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @param ger
     * @throws JogosDAOException
     */
    public void atualizar(Gerente ger) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (ger == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update gerente set "
                    + "ge_tu_id = ?, "
                    + "ge_e_id = ?, "
                    + "ge_se_id = ?, "
                    + "ge_nrMatric = ? "
                    + "where ge_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, ger.getGe_tu_id());
            ps.setInt(2, ger.getGe_e_id());
            ps.setInt(3, ger.getGe_se_id());
            ps.setString(6, ger.getGe_nrMatric());
            ps.setInt(4, ger.getGe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ge_id, ge_tu_id, ge_se_id, ge_e_id "
                    + "ge_nrMatric from gerente");
            rs = ps.executeQuery();
            List<Gerente> lista = new ArrayList<Gerente>();

            while (rs.next()) {
                Gerente ger = new Gerente();
                ger.setGe_id(rs.getInt(1));
                ger.setGe_tu_id(rs.getInt(2));
                ger.setGe_se_id(rs.getInt(3));
                ger.setGe_e_id(rs.getInt(4));
                ger.setGe_nrMatric(rs.getString(5));
                lista.add(ger);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ge_id, ge_tu_id, ge_se_id, ge_e_id, "
                    + "ge_nrMatric from gerente where ge_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Gerente> lista = new ArrayList<Gerente>();


            Gerente ger = new Gerente();
            while (rs.next()) {
                ger.setGe_id(rs.getInt(1));
                ger.setGe_tu_id(rs.getInt(2));
                ger.setGe_se_id(rs.getInt(3));
                ger.setGe_e_id(rs.getInt(4));
                ger.setGe_nrMatric(rs.getString(5));
                lista.add(ger);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @param us_id
     * @param ge_co_id
     * @return
     * @throws JogosDAOException
     */
    public Gerente listaByLogin(int us_id, int ge_co_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        String where = "";
        if (us_id > 0) {
            where = " ge_us_id = " + us_id;
        } else {
            where = " tu_co_id = " + ge_co_id;
        }
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ge_id, ge_tu_id, ge_nrMatric,  tu_noTurma, ge_e_id, ge_se_id " +
                    " from gerente left join turma on ge_tu_id = tu_id "
                    + " where " + where);

            rs = ps.executeQuery();
            Gerente ger = new Gerente();

            if ((rs != null) && (rs.next())) {//pega apenas o primeiro
                ger.setGe_id(rs.getInt(1));
                ger.setGe_tu_id(rs.getInt(2));
                ger.setGe_nrMatric(rs.getString(3));
                ger.setGe_noTurma(rs.getString(4));
                ger.setGe_e_id(rs.getInt(5));
                ger.setGe_se_id(rs.getInt(6));
            }

            return ger;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }


    /**
     *
     * @param tu_id
     * @return
     * @throws JogosDAOException
     */
    public List<JogadorAtual> listaByTurmaView(int tu_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        String sql = " select us_noEmail, us_noUsuario, se_noSetor, e_descr, tu_noTurma from usuario  " +
                "join gerente on ge_us_id = us_id join setor on se_id = ge_se_id " +
                "join empresa on e_id = ge_e_id " +
                "join turma on tu_id = ge_tu_id "
                ;
        try {
            if(tu_id>0){
                sql = sql+" where ge_tu_id = "+tu_id ;
            }
            sql = sql+" order by tu_noTurma, us_noUsuario ";
            //System.out.println(sql);
            conne = this.conn;
            ps = conne.prepareStatement(sql);
            rs = ps.executeQuery();
            JogadorAtual jog;
            List<JogadorAtual> lista = new ArrayList<JogadorAtual>();
            while(rs.next()) {
                jog = new JogadorAtual();
                jog.setUs_eNome(rs.getString(1));//vai o email
                jog.setUs_NomeLogado(rs.getString(2));//vai o usuario
                jog.setUs_noSetor(rs.getString(3));
                jog.setUs_noEmpresaTabela(rs.getString(4));
                jog.setUs_nomeTurma(rs.getString(5));
                lista.add(jog);
            }

            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle+"teste");
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
    public List listaByTurma(int tu_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select ge_id, ge_tu_id, ge_e_id, ge_se_id, ge_noGerente, ge_noEmail, "
                    + "ge_nrMatric, ge_noSenha from gerente where ge_tu_id = ? ");
            ps.setInt(1, tu_id);
            rs = ps.executeQuery();
            Gerente ger;
            List<Gerente> lista = new ArrayList<Gerente>();
            if (rs.next()) {
                ger = new Gerente();
                ger.setGe_id(rs.getInt(1));
                ger.setGe_tu_id(rs.getInt(2));
                ger.setGe_e_id(rs.getInt(3));
                ger.setGe_se_id(rs.getInt(4));
                ger.setGe_nrMatric(rs.getString(5));
                lista.add(ger);
            }

            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
    /*
    public static void main(String args[]) throws JogosDAOException{
        GerenteDAO g = new GerenteDAO();
        List<JogadorAtual> l = g.listaByTurmaView(17);
    }*/
}
