/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Coordenador;
import entidades.Empresa;
import entidades.EmpresaPeriodo;
import entidades.Gerente;
import entidades.JogadorAtual;
import entidades.Periodo;
import entidades.Setor;
import entidades.Usuario;
import java.sql.Connection;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class JogadorAtualDAO {

    private Connection conn;
    private Periodo periodo = new Periodo();

    /**
     *
     * @throws JogosDAOException
     */
    public JogadorAtualDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param jogador
     * @return
     * @throws JogosDAOException
     */
    public String validar(JogadorAtual jogador) throws JogosDAOException {
        String validado = "welcomeJSF";
        jogador.setUs_logado(false);//inicia inválido
        jogador.setUs_msgErro("");
        PeriodoDAO periodoCt;

        if (jogador == null) {
            jogador = new JogadorAtual();
            jogador.setUs_msgErro("Usuário inválido ou senha incorreta.");
            return validado;
        }
        /*EmpresaDAO daoEn = new EmpresaDAO();
        Empresa entEn = new Empresa();
        List<Empresa> eList = daoEn.listaTodos();
        entEn = (Empresa) eList.get(0);
         */
        if (jogador.getUs_login().compareTo("") == 0 || jogador.getUs_senha().compareTo("") == 0) {
            jogador.setUs_msgErro("O preenchimento de todos os campos é obrigatório.");
            return validado;
        } else {
            GerenteDAO gerenteCtrl = new GerenteDAO();
            UsuarioDAO ud = new UsuarioDAO();
            Usuario usuario = ud.listaByLogin(jogador.getUs_login(), jogador.getUs_senha());
            jogador.setUs_NomeLogado(usuario.getUs_noUsuario());
            Gerente gerente = gerenteCtrl.listaByLogin(usuario.getUs_id(), 0);
            Coordenador co = new Coordenador();
            CoordenadorDAO coD = new CoordenadorDAO();

            if (gerente.getGe_id() == 0) {
                co = coD.listaByLogin(usuario.getUs_id());
                if ((co != null) && (co.getCo_id() == 0)) {
                    jogador.setUs_msgErro("Login inválido!.");
                    return validado;
//                    throw new JogosDAOException("Login inválido, email não encontrado!");
                }
                gerenteCtrl = new GerenteDAO();
                gerente = gerenteCtrl.listaByLogin(0, co.getCo_id());
                jogador.setUs_co_chaveAcesso(co.getCo_chave_acesso());
                jogador.setUs_eCoordenador(1);//define como coordenador

            } else if (gerente.getGe_tu_id() > 0) {//salva dados do coordenador caso seja um aluno
                coD = new CoordenadorDAO();
                co = coD.listaByTurma(gerente.getGe_tu_id());
                ud = new UsuarioDAO();
                Usuario usuarioCo = ud.listaById(co.getCo_us_id());
                jogador.setUs_co_noNome(usuarioCo.getUs_noUsuario());
                jogador.setUs_noMatricula(gerente.getGe_nrMatric());
            }
            jogador.setUs_co_id(co.getCo_id());

            if ((gerente != null) && (gerente.getGe_id() > 0)) {
                jogador.setUs_idTurma(gerente.getGe_tu_id());
                jogador.setUs_nomeTurma(gerente.getGe_noTurma());
                jogador.setUs_ge_id(gerente.getGe_id());
                jogador.setUs_empresa(gerente.getGe_e_id());
                jogador.setUs_id(usuario.getUs_id());
                // buscamos o período ativo..
                if ((gerente.getGe_tu_id() > 0) && (gerente.getGe_e_id() > 0)) {
                    periodoCt = new PeriodoDAO();
                    periodo = (Periodo) periodoCt.periodoByTurmaAtivo(gerente.getGe_tu_id(), gerente.getGe_e_id());
                }
                SetorDAO idaoSe = new SetorDAO();
                Setor enSe = new Setor();
                enSe = (Setor) idaoSe.listaById(gerente.getGe_se_id());
                jogador.setUs_noSetor(enSe.getSe_noSetor());

                EmpresaDAO idaoE = new EmpresaDAO();
                Empresa enE = new Empresa();
                enE = idaoE.listaById(gerente.getGe_e_id());
                jogador.setUs_noEmpresaTabela(enE.getE_descr());
                jogador.setUs_empresa(enE.getE_id());
            }
            
            if (periodo.getPe_id() == 0) {
                periodoCt = new PeriodoDAO();
                int idTurma = (jogador.getUs_idTurma() > 0) ? jogador.getUs_idTurma() : gerente.getGe_tu_id();
                if(idTurma > 0){
                    periodo = periodoCt.periodoByTurma(idTurma);
                }
            }

            if (periodo.getPe_id() > 0) {
                jogador.setUs_periodoAtivo(periodo.getPe_id());
                jogador.setUs_idPeriodo(periodo.getPe_id());
                jogador.setUs_noPeriodo(periodo.getPe_noPeriodo());
                EmpresaPeriodo ep = new EmpresaPeriodo();
                EmpresaPeriodoDAO idaoEp = new EmpresaPeriodoDAO();
                ep = idaoEp.listaByEmpPer(gerente.getGe_e_id(), periodo.getPe_id());
                jogador.setUs_empresa_periodo(ep.getEm_id());
                jogador.setUs_empresa(ep.getEm_e_id());
                jogador.setUs_eNome(ep.getEm_nome());
            }
            jogador.setUs_logado(true);
        }

        if (jogador.getUs_msgErro().isEmpty()) {
            return "TelaInicial";
        } else {
            return validado;
        }
    }
}
