/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

/**
 *
 * @author rafael
 */
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;
import entidades.MateriaPrima;

/**
 *
 * @author rafael
 */
public class MateriaPrimaDAO {

    private Connection conn;
    /**
     *
     */
    public String campos_sql = "mp_pe_id, mp_noTipo, mp_qtUnidadeProd, mp_vlPreco,mp_pcCompraEspecial ";
	public String campos_sqls = "mp_pe_id, mp_noTipo, mp_qtUnidadeProd, mp_vlPreco,mp_pcCompraEspecial ";
    /**
     *
     */
    public String tbl_id = "mp_id";
    /**
     *
     */
    public String tabela = "materiaprima";

    /**
     *
     * @throws JogosDAOException
     */
    public MateriaPrimaDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void salvar(MateriaPrima obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (obj == null) {
            throw new JogosDAOException("O objeto utilizado não pode ser nulo.");
        }

        try {
            String temp = "?";
            for (int i = 1; i < 5; i++) {
                temp += ", ?";
            }

            String SQL = "insert into " + tabela + " (" + campos_sql + ") "
                    + "values (" + temp + ")";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;
            ps.setInt(i++, obj.getMp_tu_id());
            ps.setInt(i++, obj.getMp_pe_id());
            ps.setString(i++, obj.getMp_noTipo());
            ps.setInt(i++, obj.getMp_qtUnidadeProd());
            ps.setDouble(i++, obj.getMp_vlPreco());
            ps.setDouble(i++, obj.getMp_pcCompraEspecial());

            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void excluir(MateriaPrima obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O do objeto não pode ser nulo - delete." + obj.toString());
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from " + tabela + " where " + tbl_id + "=?");
            ps.setInt(1, obj.getMp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public void atualizar(MateriaPrima obj) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (obj == null) {
            throw new JogosDAOException("O objeto não pode ser nulo - alt.");
        }

        try {
            String SQL = "update " + tabela + " set "
                    + " mp_vlPreco = ? where " + tbl_id + " = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            int i = 1;
            /*ps.setInt(i++, obj.getMp_tu_id());
            ps.setInt(i++, obj.getMp_pe_id());
            ps.setString(i++, obj.getMp_noTipo());
            ps.setInt(i++, obj.getMp_qtUnidadeProd());*/
            ps.setDouble(i++, obj.getMp_vlPreco());
            //ps.setDouble(i++, obj.getMp_pcCompraEspecial());
            ps.setInt(i++, obj.getMp_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados MateriaPrimaDao " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " +tbl_id+ ", " + campos_sqls + " from " + tabela);
            rs = ps.executeQuery();
            List<MateriaPrima> lista = new ArrayList<MateriaPrima>();
            int i;
            while (rs.next()) {
                MateriaPrima obj = new MateriaPrima(0, 0,0,"",0,0.0,0.0);
                i=1;
                obj.setMp_id(rs.getInt(i++));
                obj.setMp_tu_id(rs.getInt(i++));
                obj.setMp_pe_id(rs.getInt(i++));
                obj.setMp_noTipo(rs.getString(i++));
                obj.setMp_qtUnidadeProd(rs.getInt(i++));
                obj.setMp_vlPreco(rs.getDouble(i++));
                obj.setMp_pcCompraEspecial(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }



     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select " +tbl_id+ ", " + campos_sqls + " from " + tabela + " where " + tbl_id + " = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<MateriaPrima> lista = new ArrayList<MateriaPrima>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }
            int i;
            while (rs.next()) {
                MateriaPrima obj = new MateriaPrima(0, 0,0,"",0,0.0,0.0);
                i=1;
                obj.setMp_id(rs.getInt(i++));
                obj.setMp_tu_id(rs.getInt(i++));
                obj.setMp_pe_id(rs.getInt(i++));
                obj.setMp_noTipo(rs.getString(i++));
                obj.setMp_qtUnidadeProd(rs.getInt(i++));
                obj.setMp_vlPreco(rs.getDouble(i++));
                obj.setMp_pcCompraEspecial(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param pe_id
     * @param noTipo
     * @return
     * @throws JogosDAOException
     */
    public MateriaPrima mpByNo(int pe_id, String noTipo) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT mp_id, mp_pe_id, mp_noTipo, mp_qtUnidadeProd, mp_vlPreco, mp_pcCompraEspecial from materiaprima WHERE mp_pe_id = " + pe_id + " AND mp_noTipo = '" + noTipo + "'";

            ps = conne.prepareStatement(sql);

            rs = ps.executeQuery();
            MateriaPrima mp = new MateriaPrima(0, 0,0,"",0,0.0,0.0);
            if (rs.next()) {
                mp.setMp_id(rs.getInt(1));
                mp.setMp_pe_id(rs.getInt(2));
                mp.setMp_noTipo(rs.getString(3));
                mp.setMp_qtUnidadeProd(rs.getInt(4));
                mp.setMp_vlPreco(rs.getDouble(5));
                mp.setMp_pcCompraEspecial(rs.getDouble(6));
            }
            return mp;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


     
    /**
     *
     * @param pe_id
     * @return
     * @throws JogosDAOException
     */
    public List listaByPeriodo(int pe_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            
            ps = conne.prepareStatement("select " +tbl_id+ ", " + campos_sqls + " from " + tabela + " where mp_pe_id = ?");
            ps.setInt(1, pe_id);
            rs = ps.executeQuery();
            List<MateriaPrima> lista = new ArrayList<MateriaPrima>();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + pe_id);
            }
            int i;
            while (rs.next()) {
                MateriaPrima obj = new MateriaPrima(0, 0,0,"",0,0.0,0.0);
                i=1;
                obj.setMp_id(rs.getInt(i++));
                obj.setMp_pe_id(rs.getInt(i++));
                obj.setMp_noTipo(rs.getString(i++));
                obj.setMp_qtUnidadeProd(rs.getInt(i++));
                obj.setMp_vlPreco(rs.getDouble(i++));
                obj.setMp_pcCompraEspecial(rs.getDouble(i++));
                lista.add(obj);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
