/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.ParamFixo;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class ParamFixoDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public ParamFixoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param pfx
     * @throws JogosDAOException
     */
    public void salvar(ParamFixo pfx) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        System.out.println("metodo salvar..");
        if (pfx == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }
        System.out.println("não era nulo..");
        try {
            String SQL = "insert into paramfixo (pf_tu_id, pf_vlTerreno, pf_vlPredio, "
                    + "pf_pcVarMaquinas) values (?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, pfx.getPf_tu_id());
            ps.setDouble(2, pfx.getPf_vlTerreno());
            ps.setDouble(3, pfx.getPf_vlPredio());
            ps.setDouble(4, pfx.getPf_pcVarMaquinas());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param pfx
     * @throws JogosDAOException
     */
    public void excluir(ParamFixo pfx) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pfx == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from paramfixo where pf_id=?");
            ps.setInt(1, pfx.getPf_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param pfx
     * @throws JogosDAOException
     */
    public void atualizar(ParamFixo pfx) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pfx == null) {
            throw new JogosDAOException("O valor passado não pode ser ParamFixo atualizar.");
        }

        try {
            String SQL = "update paramfixo set "
                    + "pf_tu_id = ?, "
                    + "pf_vlPredio = ?, "
                    + "pf_vlTerreno = ?, "
                    + "pf_pcVarMaquinas = ? "
            + "where pf_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, pfx.getPf_tu_id());
            ps.setDouble(2, pfx.getPf_vlPredio());
            ps.setDouble(3, pfx.getPf_vlTerreno());
            ps.setDouble(4, pfx.getPf_pcVarMaquinas());
            ps.setInt(5, pfx.getPf_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados Execute Atualizar" + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
     
    /**
     *
     * @param pfx
     * @throws JogosDAOException
     */
    public void atualizarC5(ParamFixo pfx) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (pfx == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update paramfixo set "
                    + "pf_pcVarMaquinas = ? ";
            //+ "where pf_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setDouble(1, pfx.getPf_pcVarMaquinas());
            //ps.setInt(5, pfx.getPf_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public ParamFixo getPF() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pf_id, pf_vlTerreno, pf_vlPredio, "
                    + "pf_pcVarMaquinas from paramfixo order by pf_id desc limit 1");
            rs = ps.executeQuery();
            List<ParamFixo> lista = new ArrayList<ParamFixo>();
            ParamFixo pfx = new ParamFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
            while (rs.next()) {
                pfx.setPf_id(rs.getInt(1));
                pfx.setPf_tu_id(rs.getInt(2));
                pfx.setPf_vlTerreno(rs.getDouble(3));
                pfx.setPf_vlPredio(rs.getDouble(4));
                pfx.setPf_pcVarMaquinas(rs.getDouble(5));
            }
            return pfx;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pf_id, pf_vlTerreno, pf_vlPredio,"
                    + "pf_pcVarMaquinas from paramfixo");
            rs = ps.executeQuery();
            List<ParamFixo> lista = new ArrayList<ParamFixo>();
            while (rs.next()) {
                ParamFixo pfx = new ParamFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
                pfx.setPf_id(rs.getInt(1));
                pfx.setPf_tu_id(rs.getInt(2));
                pfx.setPf_vlPredio(rs.getDouble(3));
                pfx.setPf_vlTerreno(rs.getDouble(4));
                pfx.setPf_pcVarMaquinas(rs.getDouble(5));
                lista.add(pfx);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public ParamFixo listaPF() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pf_id, pf_vlTerreno, pf_vlPredio, "
                    + "pf_pcVarMaquinas from paramfixo order by pf_id desc limit 1");
            rs = ps.executeQuery();
            //List<ParamFixo> lista = new ArrayList<ParamFixo>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro.");
            }
            ParamFixo pfx = new ParamFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
            while (rs.next()) {
                pfx.setPf_id(rs.getInt(1));
                pfx.setPf_tu_id(rs.getInt(2));
                pfx.setPf_vlPredio(rs.getDouble(3));
                pfx.setPf_vlTerreno(rs.getDouble(4));
                pfx.setPf_pcVarMaquinas(rs.getDouble(5));
            }
            return pfx;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }

    /**
     *
     * @param tu_id
     * @return
     * @throws JogosDAOException
     */
    public ParamFixo pfByTuId(int tu_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT pf_id, pf_tu_id, pf_vlPredio, pf_vlTerreno, pf_pcVarMaquinas FROM paramfixo WHERE pf_tu_id = " + tu_id;

            ps = conne.prepareStatement(sql);

            rs = ps.executeQuery();
            ParamFixo pfx = new ParamFixo(0, 0, 0.0, 0.0, 0.0, 0.0);
            if (rs.next()) {
                pfx.setPf_id(rs.getInt(1));
                pfx.setPf_tu_id(rs.getInt(2));
                pfx.setPf_vlPredio(rs.getDouble(3));
                pfx.setPf_vlTerreno(rs.getDouble(4));
                pfx.setPf_pcVarMaquinas(rs.getDouble(5));
            }
            return pfx;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
}
