/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Produtividade;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

/**
 *
 * @author rafael
 */
public class ProdutividadeDAO  {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public ProdutividadeDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param prd
     * @throws JogosDAOException
     */
    public void salvar(Produtividade prd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (prd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into produtividade (pd_em_id, pd_pcNivelAtividade, pd_pcHoraExtra, "
                    + "pd_pcIndProdutividade) values (?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, prd.getPd_em_id());
            ps.setDouble(2, prd.getPd_pcNivelAtividade());
            ps.setDouble(3, prd.getPd_pcHoraExtra());
            ps.setDouble(4, prd.getPd_pcIndProdutividade());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param prd
     * @throws JogosDAOException
     */
    public void excluir(Produtividade prd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (prd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from produtividade where pd_id = ?");
            ps.setInt(1, prd.getPd_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param prd
     * @throws JogosDAOException
     */
    public void atualizar(Produtividade prd) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (prd == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update produtividade set "
            //        + "pd_em_id = ?, "
                    + "pd_pcNivelAtividade = ?, "
                    + "pd_pcHoraExtra = ?, "
                    + "pd_pcIndProdutividade = ? "
                    + "where pd_em_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            //ps.setInt(1, prd.getPd_em_id());
            ps.setDouble(1, prd.getPd_pcNivelAtividade());
            ps.setDouble(2, prd.getPd_pcHoraExtra());
            ps.setDouble(3, prd.getPd_pcIndProdutividade());
            ps.setInt(4, prd.getPd_em_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pd_id, pd_em_id, pd_pcNivelAtividade, pd_pcHoraExtra, "
                    + "pd_pcIndProdutividade from produtividade");
            rs = ps.executeQuery();
            List<Produtividade> lista = new ArrayList<Produtividade>();

            while (rs.next()) {
                Produtividade prd = new Produtividade();
                prd.setPd_id(rs.getInt(1));
                prd.setPd_em_id(rs.getInt(2));
                prd.setPd_pcNivelAtividade(rs.getDouble(3));
                prd.setPd_pcHoraExtra(rs.getDouble(4));
                prd.setPd_pcIndProdutividade(rs.getDouble(5));
                lista.add(prd);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pd_id, pd_em_id, pd_pcNivelAtividade, pd_pcHoraExtra, "
                    + "pd_pcIndProdutividade from produtividade where pd_em_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Produtividade> lista = new ArrayList<Produtividade>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }

            while (rs.next()) {
                Produtividade prd = new Produtividade();
                prd.setPd_id(rs.getInt(1));
                prd.setPd_em_id(rs.getInt(2));
                prd.setPd_pcNivelAtividade(rs.getDouble(3));
                prd.setPd_pcHoraExtra(rs.getDouble(4));
                prd.setPd_pcIndProdutividade(rs.getDouble(5));
                lista.add(prd);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param em_id
     * @return
     * @throws JogosDAOException
     */
    public Produtividade getById(int em_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pd_id, pd_em_id, pd_pcNivelAtividade, pd_pcHoraExtra, "
                    + "pd_pcIndProdutividade from produtividade where pd_em_id = ?");
            ps.setInt(1, em_id);
            rs = ps.executeQuery();

            if (rs == null) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + em_id);
            }

            Produtividade prd = new Produtividade();
            while (rs.next()) {
                prd.setPd_id(rs.getInt(1));
                prd.setPd_em_id(rs.getInt(2));
                prd.setPd_pcNivelAtividade(rs.getDouble(3));
                prd.setPd_pcHoraExtra(rs.getDouble(4));
                prd.setPd_pcIndProdutividade(rs.getDouble(5));
            }
            return prd;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaByEpPr(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select pd_id, pd_em_id, pd_pcNivelAtividade, pd_pcHoraExtra, "
                    + "pd_pcIndProdutividade from produtividade where pd_em_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Produtividade> lista = new ArrayList<Produtividade>();

            if (!rs.next()) {
                throw new JogosDAOException("Nao foi encontrado nenhum registro com o id: " + id);
            }

            while (rs.next()) {
                Produtividade prd = new Produtividade();
                prd.setPd_id(rs.getInt(1));
                prd.setPd_em_id(rs.getInt(2));
                prd.setPd_pcNivelAtividade(rs.getDouble(3));
                prd.setPd_pcHoraExtra(rs.getDouble(4));
                prd.setPd_pcIndProdutividade(rs.getDouble(5));
                lista.add(prd);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }
}
