/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidades.Regiao;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.faces.model.SelectItem;
import util.ConexaoFactory;

/**
 *
 * @author Doglei
 */
public class RegiaoDAO  {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public RegiaoDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

     
    /**
     *
     * @param regiao
     * @throws JogosDAOException
     */
    public void salvar(Regiao regiao) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (regiao == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - ins.");
        }

        try {
            String SQL = "insert into regiao (" +
                    "re_em_id, " +
                    "re_noRegiao, " +
                    "re_nrPrazo, " +
                    "re_nrDemanda, "
                    + "re_nrMetasVenda, " +
                    "re_qtVendida, " +
                    "re_qtPropaganda, " +
                    "re_pcMargem, " +
                    "re_vlPreco, "
                    + "re_vlPrecoProd, " +
                    "re_vlReceita) "
                    + "values (?,?,?,?,?,?,?,?,?,?,?)";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, regiao.getRe_em_id());
            ps.setString(2, regiao.getRe_noRegiao());
            ps.setInt(3, regiao.getRe_nrPrazo());
            ps.setInt(4, regiao.getRe_nrDemanda());
            ps.setInt(5, regiao.getRe_nrMetasVenda());
            ps.setInt(6, regiao.getRe_qtVendida());
            ps.setInt(7, regiao.getRe_qtPropaganda());
            ps.setDouble(8, regiao.getRe_pcMargem());
            ps.setDouble(9, regiao.getRe_vlPreco());
            ps.setDouble(10, regiao.getRe_vlPrecoProd());
            ps.setDouble(11, regiao.getRe_vlReceita());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param regiao
     * @throws JogosDAOException
     */
    public void excluir(Regiao regiao) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (regiao == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - exc.");
        }

        try {
            conne = this.conn;
            ps = conne.prepareStatement("delete from regiao where re_id=?");
            ps.setInt(1, regiao.getRe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao excluir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param regiao
     * @throws JogosDAOException
     */
    public void atualizar(Regiao regiao) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (regiao == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update regiao set "
                    + "re_em_id = ?, "
                    + "re_noRegiao = ?, "
                    + "re_nrPrazo = ?, "
                    + "re_nrDemanda = ?, "
                    + "re_nrMetasVenda = ?, "
                    + "re_qtVendida = ?, "
                    + "re_qtPropaganda = ?, "
                    + "re_pcMargem = ?, "
                    + "re_vlPreco = ?, "
                    + "re_vlPrecoProd = ?, "
                    + "re_vlReceita = ? "
                    + "where re_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, regiao.getRe_em_id());
            ps.setString(2, regiao.getRe_noRegiao());
            ps.setInt(3, regiao.getRe_nrPrazo());
            ps.setInt(4, regiao.getRe_nrDemanda());
            ps.setInt(5, regiao.getRe_nrMetasVenda());
            ps.setInt(6, regiao.getRe_qtVendida());
            ps.setInt(7, regiao.getRe_qtPropaganda());
            ps.setDouble(8, regiao.getRe_pcMargem());
            ps.setDouble(9, regiao.getRe_vlPreco());
            ps.setDouble(10, regiao.getRe_vlPrecoProd());
            ps.setDouble(11, regiao.getRe_vlReceita());
            ps.setInt(12, regiao.getRe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @param regiao
     * @throws JogosDAOException
     */
    public void atualizarVendas(Regiao regiao) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (regiao == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update regiao set "
                    + "re_em_id = ?, "
                    + "re_noRegiao = ?, "
                    + "re_nrPrazo = ?, "
                    + "re_nrMetasVenda = ?, "
                    + "re_qtPropaganda = ?, "
                    + "re_pcMargem = ?, "
                    + "re_vlPreco = ? "
                    + "where re_id=?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, regiao.getRe_em_id());
            ps.setString(2, regiao.getRe_noRegiao());
            ps.setInt(3, regiao.getRe_nrPrazo());
            ps.setInt(4, regiao.getRe_nrMetasVenda());
            ps.setInt(5, regiao.getRe_qtPropaganda());
            ps.setDouble(6, regiao.getRe_pcMargem());
            ps.setDouble(7, regiao.getRe_vlPreco());
            ps.setInt(8, regiao.getRe_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List listaTodos() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select re_em_id, re_noRegiao, re_nrPrazo, re_nrDemanda, "
                    + "re_nrMetasVenda, re_qtVendida, re_qtPropaganda, re_pcMargem, re_vlPreco, "
                    + "re_vlPrecoProd, re_vlReceita from regiao");
            rs = ps.executeQuery();
            List<Regiao> lista = new ArrayList<Regiao>();
            while (rs.next()) {
                Regiao regiao = new Regiao(0, 0, "", 0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
                regiao.setRe_em_id(rs.getInt(1));
                regiao.setRe_noRegiao(rs.getString(2));
                regiao.setRe_nrPrazo(rs.getInt(3));
                regiao.setRe_nrDemanda(rs.getInt(4));
                regiao.setRe_nrMetasVenda(rs.getInt(5));
                regiao.setRe_qtVendida(rs.getInt(6));
                regiao.setRe_qtPropaganda(rs.getInt(7));
                regiao.setRe_pcMargem(rs.getDouble(8));
                regiao.setRe_vlPreco(rs.getDouble(9));
                regiao.setRe_vlPrecoProd(rs.getDouble(10));
                regiao.setRe_vlReceita(rs.getDouble(11));
                regiao.setRe_id(rs.getInt(12));

                lista.add(regiao);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaById(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select re_id, re_em_id, re_noRegiao, re_nrPrazo, re_nrDemanda, "
                    + "re_nrMetasVenda, re_qtVendida, re_qtPropaganda, re_pcMargem, re_vlPreco, "
                    + "re_vlPrecoProd, re_vlReceita from regiao where re_id = ?");
            ps.setInt(1, id);
            rs = ps.executeQuery();
            List<Regiao> lista = new ArrayList<Regiao>();

            while (rs.next()) {
                Regiao regiao = new Regiao(0, 0, "", 0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
                regiao.setRe_id(rs.getInt(1));
                regiao.setRe_em_id(rs.getInt(2));
                regiao.setRe_noRegiao(rs.getString(3));
                regiao.setRe_nrPrazo(rs.getInt(4));
                regiao.setRe_nrDemanda(rs.getInt(5));
                regiao.setRe_nrMetasVenda(rs.getInt(6));
                regiao.setRe_qtVendida(rs.getInt(7));
                regiao.setRe_qtPropaganda(rs.getInt(8));
                regiao.setRe_pcMargem(rs.getDouble(9));
                regiao.setRe_vlPreco(rs.getDouble(10));
                regiao.setRe_vlPrecoProd(rs.getDouble(11));
                regiao.setRe_vlReceita(rs.getDouble(12));
                lista.add(regiao);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public List<SelectItem> listaForMenu() throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select re_id, re_noRegiao from regiao");
            rs = ps.executeQuery();
            List<SelectItem> lista = new ArrayList<SelectItem>();

            while (rs.next()) {
                SelectItem tipo = new SelectItem(rs.getString(1), rs.getString(2));
                lista.add(tipo);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param regiaodigitada
     * @return
     * @throws JogosDAOException
     */
    public Regiao listaByDesc(String regiaodigitada) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select re_em_id, re_noRegiao, re_nrPrazo, re_nrDemanda, "
                    + "re_nrMetasVenda, re_qtVendida, re_qtPropaganda, re_pcMargem, re_vlPreco, "
                    + "re_vlPrecoProd, re_vlReceita from regiao where "
                    + "re_noRegiao = ? and re_em_id = ? limit 1");
            ps.setString(1, regiaodigitada);
            // ver como ficará a leitura por session - id do empresaperíodo
            ps.setInt(2, 1);
            rs = ps.executeQuery();

            Regiao regiao = new Regiao(0, 0, "", 0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
            while (rs.next()) {
                regiao.setRe_em_id(rs.getInt(1));
                regiao.setRe_noRegiao(rs.getString(2));
                regiao.setRe_nrPrazo(rs.getInt(3));
                regiao.setRe_nrDemanda(rs.getInt(4));
                regiao.setRe_nrMetasVenda(rs.getInt(5));
                regiao.setRe_qtVendida(rs.getInt(6));
                regiao.setRe_qtPropaganda(rs.getInt(7));
                regiao.setRe_pcMargem(rs.getDouble(8));
                regiao.setRe_vlPreco(rs.getDouble(9));
                regiao.setRe_vlPrecoProd(rs.getDouble(10));
                regiao.setRe_vlReceita(rs.getDouble(11));
                regiao.setRe_id(rs.getInt(12));
            }
            return regiao;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

     
    /**
     *
     * @param id
     * @return
     * @throws JogosDAOException
     */
    public List listaByEM(int id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = conne.prepareStatement("select re_id, re_em_id, re_noRegiao, re_nrPrazo, re_nrDemanda, "
                    + "re_nrMetasVenda, re_qtVendida, re_qtPropaganda, re_pcMargem, re_vlPreco, "
                    + "re_vlPrecoProd, re_vlReceita from regiao where "
                    + "re_em_id = ?");

            ps.setInt(1, id);

            rs = ps.executeQuery();
            List<Regiao> lista = new ArrayList<Regiao>();

            while (rs.next()) {
                Regiao regiao = new Regiao(0, 0, "", 0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
                regiao.setRe_id(rs.getInt(1));
                regiao.setRe_em_id(rs.getInt(2));
                regiao.setRe_noRegiao(rs.getString(3));
                regiao.setRe_nrPrazo(rs.getInt(4));
                regiao.setRe_nrDemanda(rs.getInt(5));
                regiao.setRe_nrMetasVenda(rs.getInt(6));
                regiao.setRe_qtVendida(rs.getInt(7));
                regiao.setRe_qtPropaganda(rs.getInt(8));
                regiao.setRe_pcMargem(rs.getDouble(9));
                regiao.setRe_vlPreco(rs.getDouble(10));
                regiao.setRe_vlPrecoProd(rs.getDouble(11));
                regiao.setRe_vlReceita(rs.getDouble(12));
                lista.add(regiao);
            }
            return lista;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }
    }

    /**
     *
     * @param em_id
     * @param re_no
     * @return
     * @throws JogosDAOException
     */
    public Regiao getRegiao(int em_id, String re_no) throws JogosDAOException{
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "select * from regiao where re_em_id = " + em_id + " and re_noRegiao = " + re_no;

            ps = conne.prepareStatement(sql);

            rs = ps.executeQuery();
            Regiao regiao = new Regiao(0, 0, "", 0, 0, 0, 0, 0, 0.0, 0.0, 0.0, 0.0);
            if (rs.next()) {
                regiao.setRe_id(rs.getInt(1));
                regiao.setRe_em_id(rs.getInt(2));
                regiao.setRe_noRegiao(rs.getString(3));
                regiao.setRe_nrPrazo(rs.getInt(4));
                regiao.setRe_nrDemanda(rs.getInt(5));
                regiao.setRe_nrMetasVenda(rs.getInt(6));
                regiao.setRe_qtVendida(rs.getInt(7));
                regiao.setRe_qtPropaganda(rs.getInt(8));
                regiao.setRe_pcMargem(rs.getDouble(9));
                regiao.setRe_vlPreco(rs.getDouble(10));
                regiao.setRe_vlPrecoProd(rs.getDouble(11));
                regiao.setRe_vlReceita(rs.getDouble(12));
            }
            return regiao;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }


/*    public static void main (String args[]) throws JogosDAOException{
        RegiaoDAO reDAO = new RegiaoDAO();
        Iterator i = reDAO.listaByEM(114).iterator();
        while(i.hasNext()){
            Regiao r = (Regiao)i.next();
            System.out.println(
                    r.getRe_id() + "   " +
                    r.getRe_em_id() + "   " +
                    r.getRe_qtVendida()
                    );
        }
    }*/
}
