/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import util.ConexaoFactory;
import entidades.Usuario;

/**
 *
 * @author rafael
 */
public class UsuarioDAO {

    private Connection conn;

    /**
     *
     * @throws JogosDAOException
     */
    public UsuarioDAO() throws JogosDAOException {
        try {
            this.conn = (Connection) ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    /**
     *
     * @param email
     * @param senha
     * @return
     * @throws JogosDAOException
     */
    public Usuario listaByLogin(String email, String senha) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select us_id, us_noSenha, us_noEmail, us_noUsuario from usuario  "
                    + " where us_noSenha = ? and us_noEmail = ? ");

            ps.setString(1, senha);
            ps.setString(2, email);
            rs = ps.executeQuery();
            Usuario obj = new Usuario();

            if (rs.next()) {
                obj.setUs_id(rs.getInt("us_id"));
                obj.setUs_noSenha(rs.getString("us_noSenha"));
                obj.setUs_noSenhaConf(rs.getString("us_noSenha"));
                obj.setUs_noEmail(rs.getString("us_noEmail"));
                obj.setUs_noUsuario(rs.getString("us_noUsuario"));
            }

            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }

    public Usuario listaById(int us) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select us_id, us_noSenha, us_noEmail, us_noUsuario from usuario  "
                    + " where us_id = ? ");

            ps.setInt(1, us);
            rs = ps.executeQuery();
            Usuario obj = new Usuario();

            if (rs.next()) {
                obj.setUs_id(rs.getInt("us_id"));
                obj.setUs_noSenha(rs.getString("us_noSenha"));
                obj.setUs_noSenhaConf(rs.getString("us_noSenha"));
                obj.setUs_noEmail(rs.getString("us_noEmail"));
                obj.setUs_noUsuario(rs.getString("us_noUsuario"));
            }

            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }

    /**
     *
     * @param email
     * @return
     * @throws JogosDAOException
     */
    public Usuario verificaEmail(String email) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement("select count(*) as us_id from usuario  "
                    + " where us_noEmail = ? ");
            ps.setString(1, email);
            rs = ps.executeQuery();
            Usuario obj = new Usuario();
            if (rs.next()) {
                obj.setUs_id(rs.getInt(1));
            }
            return obj;
        } catch (SQLException sqle) {
            throw new JogosDAOException(sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps, rs);
        }

    }

    /**
     *
     * @param us
     * @throws JogosDAOException
     */
    public void salvar(Usuario us) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;

        if (us == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - UsuárioDAO-SALVAR.");
        }

        try {
            String SQL = "insert into usuario (us_noSenha, us_noEmail, us_noUsuario) "
                    + "values (?,?,?)";
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement(SQL);
            ps.setString(1, us.getUs_noSenha());
            ps.setString(2, us.getUs_noEmail());
            ps.setString(3, us.getUs_noUsuario());

            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    public void atualizar(Usuario us) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;

        if (us == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - UsuárioDAO-ATUALIZAR.");
        }

        try {
            String SQL = "update usuario set us_noSenha=?, us_noEmail=?, us_noUsuario=? where us_id = ?";
            conne = this.conn;
            ps = (PreparedStatement) conne.prepareStatement(SQL);
            ps.setString(1, us.getUs_noSenha());
            ps.setString(2, us.getUs_noEmail());
            ps.setString(3, us.getUs_noUsuario());
            ps.setInt(4, us.getUs_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }
}
