package dao;

import entidades.VariacaoValorMaquina;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import util.ConexaoFactory;

public class VariacaoValorMaquinaDAO  {

    private Connection conn;


    public VariacaoValorMaquinaDAO() throws JogosDAOException {
        try {
            this.conn = ConexaoFactory.getConnection();
        } catch (Exception e) {
            throw new JogosDAOException("Erro: " + ": \n" + e.getMessage());
        }
    }

    public VariacaoValorMaquina VariacaoByPeTmId(int pe_id, int tm_id) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        ResultSet rs = null;
        try {
            conne = this.conn;
            String sql = "SELECT vvm_id, vvm_pe_id, vvm_tm_id, vvm_pcVariacao FROM variacao_valor_maquina where vvm_pe_id = " + pe_id + " and vvm_tm_id = " + tm_id;

            ps = conne.prepareStatement(sql);

            rs = ps.executeQuery();
            VariacaoValorMaquina vvm = new VariacaoValorMaquina();
            if (rs.next()) {
                vvm.setVvm_id(rs.getInt(1));
                vvm.setVvm_pe_id(rs.getInt(2));
                vvm.setVvm_tm_id(rs.getInt(3));
                vvm.setVvm_pcVariacao(rs.getDouble(4));
            }
            return vvm;
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao inserir dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

    public void atualizar(VariacaoValorMaquina vvm) throws JogosDAOException {
        PreparedStatement ps = null;
        Connection conne = null;
        if (vvm == null) {
            throw new JogosDAOException("O valor passado não pode ser nulo - alt.");
        }

        try {
            String SQL = "update variacao_valor_maquina set "
                    + "vvm_pe_id = ?, "
                    + "vvm_tm_id = ?, "
                    + "vvm_pcVariacao = ?"
                    + "where vvm_id = ?";
            conne = this.conn;
            ps = conne.prepareStatement(SQL);
            ps.setInt(1, vvm.getVvm_pe_id());
            ps.setInt(2, vvm.getVvm_tm_id());
            ps.setDouble(3, vvm.getVvm_pcVariacao());
            ps.setInt(4, vvm.getVvm_id());
            ps.executeUpdate();
        } catch (SQLException sqle) {
            throw new JogosDAOException("Erro ao atualizar dados " + sqle);
        } finally {
            ConexaoFactory.closeConnection(conne, ps);
        }
    }

}
