package entidades;

import dao.FolhaPagamentoDAO;
import dao.JogosDAOException;
import dao.TipoMaquinaDAO;
import dao.MaquinaPeriodoDAO;
import dao.PessoalDAO;

/**
 *
 * @author rafael
 */
public class CapacidadeProducao {

    /**
     *
     * @param em_id
     * @param noTipo
     * @return
     * @throws JogosDAOException
     */
    public double qtMaquinas(int em_id, String noTipo) throws JogosDAOException{
        double qtMaquinas = 0.0;
        TipoMaquinaDAO tmDAO = new TipoMaquinaDAO();
        TipoMaquina tm = tmDAO.byTipo(noTipo);
        MaquinaPeriodoDAO mqDAO = new MaquinaPeriodoDAO();
        qtMaquinas = mqDAO.qtdeMaquinasPorTipo(em_id, tm.getTm_id());
        return qtMaquinas;
    }

    /**
     *
     * @param em_id
     * @param tm
     * @return
     * @throws JogosDAOException
     */
    public double qtEmpregadosAlocados(int em_id, String tm) throws JogosDAOException{
        double qtEmpregadosAlocados = 0;
        double qtEmpMaqA = 0;
        double qtEmpMaqB = 0;
        double qtEmpMaqG = 0;

        PessoalDAO pesDAO = new PessoalDAO();
        Pessoal pes = pesDAO.pessoalBySetor(em_id, "Producao");
        FolhaPagamentoDAO fpDAO = new FolhaPagamentoDAO();
        FolhaPagamento fp = fpDAO.getFolhaObj(em_id);
        int psQtEmpregados = pes.getPs_qtEmpregados() + fp.getFp_nrAdmitidos();

        TipoMaquinaDAO tmDAOA = new TipoMaquinaDAO();
        TipoMaquina tipoA = tmDAOA.byTipo("Alfa");

        TipoMaquinaDAO tmDAOB = new TipoMaquinaDAO();
        TipoMaquina tipoB = tmDAOB.byTipo("Beta");

        TipoMaquinaDAO tmDAOG = new TipoMaquinaDAO();
        TipoMaquina tipoG = tmDAOG.byTipo("Gama");

        if((tipoA.getTm_qtEmpregados()* qtMaquinas(em_id, "Alfa") != 0)){
            if((tipoA.getTm_qtEmpregados() * qtMaquinas(em_id, "Alfa")) <= psQtEmpregados){
                qtEmpMaqA = tipoA.getTm_qtEmpregados() * qtMaquinas(em_id, "Alfa");
            }
            else{
                qtEmpMaqA = psQtEmpregados;
            }
        }

        if((tipoB.getTm_qtEmpregados() * qtMaquinas(em_id, "Beta")) != 0){
            if((tipoB.getTm_qtEmpregados() * qtMaquinas(em_id, "Beta")) <= (pes.getPs_qtEmpregados() - qtEmpMaqA)){
                qtEmpMaqB = tipoB.getTm_qtEmpregados()*qtMaquinas(em_id, "Beta");
            }
            else{
                qtEmpMaqB = psQtEmpregados - qtEmpMaqA;
            }

        }

        if((tipoG.getTm_qtEmpregados()* qtMaquinas(em_id, "Gama")) != 0){
            if((tipoG.getTm_qtEmpregados() *qtMaquinas(em_id, "Gama")) <= (psQtEmpregados - qtEmpMaqA - qtEmpMaqB)){
                qtEmpMaqG = tipoG.getTm_qtEmpregados() *qtMaquinas(em_id, "Gama");
            }
            else{
                qtEmpMaqG = psQtEmpregados - qtEmpMaqA - qtEmpMaqB;
            }
        }

        if(tm.compareTo("Alfa") == 0){
            qtEmpregadosAlocados = qtEmpMaqA;
        }
        if(tm.compareTo("Beta") == 0){
            qtEmpregadosAlocados = qtEmpMaqB;
        }
        if(tm.compareTo("Gama") == 0){
            qtEmpregadosAlocados = qtEmpMaqG;
        }
        return qtEmpregadosAlocados;
    }

    /**
     *
     * @param em_id
     * @param noTipo
     * @return
     * @throws JogosDAOException
     */
    public double capacidade(int em_id, String noTipo) throws JogosDAOException{
        double capacidade = 0.0;
        double resultado = 0.0;
        TipoMaquinaDAO tmDAO = new TipoMaquinaDAO();
        TipoMaquina tm = tmDAO.byTipo(noTipo);
        resultado = (qtEmpregadosAlocados(em_id, noTipo) * tm.getTm_qtCapacidade());
        if(resultado != 0.0){
            capacidade =  resultado/ tm.getTm_qtEmpregados();
        }

        return capacidade;
        
    }
    

/*    public static void main (String args[]) throws JogosDAOException{
        CapacidadeProducao cp = new CapacidadeProducao();
        System.out.println(cp.capacidade(106, "Alfa"));

    }*/

}
