package entidades;

import dao.CompraVendaMaquinaDAO;
import dao.EmpresaPeriodoDAO;
import dao.JogosDAOException;
import dao.MaquinaPeriodoDAO;
import dao.TipoMaquinaDAO;
import dao.VariacaoValorMaquinaDAO;
import entidades.EmpresaPeriodo;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.List;

public class CompraVendaMaquina {
    private int cvm_id;
    private int cvm_pe_id;
    private int cvm_em_id;
    private int cvm_tm_id;
    private String cvm_noTipoTransacao;
    private int cvm_nrQtde;

    public CompraVendaMaquina(int cvm_id, int cvm_pe_id, int cvm_em_id, int cvm_tm_id, String cvm_noTipoTransacao, int cvm_nrQtde) {
        this.cvm_id = cvm_id;
        this.cvm_pe_id = cvm_pe_id;
        this.cvm_em_id = cvm_em_id;
        this.cvm_tm_id = cvm_tm_id;
        this.cvm_noTipoTransacao = cvm_noTipoTransacao;
        this.cvm_nrQtde = cvm_nrQtde;
    }

    public CompraVendaMaquina() {
        this.cvm_id = 0;
        this.cvm_pe_id = 0;
        this.cvm_em_id = 0;
        this.cvm_tm_id = 0;
        this.cvm_noTipoTransacao = "";
        this.cvm_nrQtde = 0;
    }

    public CompraVendaMaquina(CompraVendaMaquina obj){
        this.cvm_id = obj.getCvm_id();
        this.cvm_pe_id = obj.getCvm_pe_id();
        this.cvm_em_id = obj.getCvm_em_id();
        this.cvm_tm_id = obj.getCvm_tm_id();
        this.cvm_noTipoTransacao = obj.getCvm_noTipoTransacao();
        this.cvm_nrQtde = obj.getCvm_nrQtde();
    }

    public int getCvm_em_id() {
        return cvm_em_id;
    }

    public void setCvm_em_id(int cvm_em_id) {
        this.cvm_em_id = cvm_em_id;
    }

    public int getCvm_id() {
        return cvm_id;
    }

    public void setCvm_id(int cvm_id) {
        this.cvm_id = cvm_id;
    }

    public String getCvm_noTipoTransacao() {
        return cvm_noTipoTransacao;
    }

    public void setCvm_noTipoTransacao(String cvm_noTipoTransacao) {
        this.cvm_noTipoTransacao = cvm_noTipoTransacao;
    }

    public int getCvm_nrQtde() {
        return cvm_nrQtde;
    }

    public void setCvm_nrQtde(int cvm_nrQtde) {
        this.cvm_nrQtde = cvm_nrQtde;
    }

    public int getCvm_pe_id() {
        return cvm_pe_id;
    }

    public void setCvm_pe_id(int cvm_pe_id) {
        this.cvm_pe_id = cvm_pe_id;
    }

    public int getCvm_tm_id() {
        return cvm_tm_id;
    }

    public void setCvm_tm_id(int cvm_tm_id) {
        this.cvm_tm_id = cvm_tm_id;
    }

    public void vender() throws JogosDAOException{
        double qtProxPeriodo = 0.0;
        double qtMaquinas = 0.0;
        CapacidadeProducao cp = new CapacidadeProducao();
        TipoMaquinaDAO tmDAO = new TipoMaquinaDAO();
        TipoMaquina tm = tmDAO.byId(this.cvm_tm_id);
        qtMaquinas = cp.qtMaquinas(this.cvm_em_id, tm.getTm_noTipo());
        qtProxPeriodo = qtMaquinas - this.getCvm_nrQtde();
            MaquinaPeriodoDAO mqDAO = new MaquinaPeriodoDAO();
            Iterator i = mqDAO.listaByEmpTipo(this.cvm_em_id, this.cvm_tm_id).iterator();
            while(i.hasNext() && qtProxPeriodo > 0){
                    MaquinaPeriodo mq = (MaquinaPeriodo)i.next();
                    mq.setMq_em_id(this.cvm_em_id + 8);
                    mq.setMq_nrIdade(mq.getMq_nrIdade() + 1);
                    mqDAO = new MaquinaPeriodoDAO();
                    mqDAO.salvar(mq);
                    qtProxPeriodo--;
        }
    }

    public void comprar() throws JogosDAOException{
        MaquinaPeriodoDAO mqDAO;
        MaquinaPeriodo mq;
        
        VariacaoValorMaquinaDAO vvmDAO = new VariacaoValorMaquinaDAO();
        VariacaoValorMaquina vvm = vvmDAO.VariacaoByPeTmId(this.cvm_pe_id, this.cvm_tm_id);
        
        TipoMaquinaDAO tmDAO = new TipoMaquinaDAO();
        TipoMaquina tm = tmDAO.byId(this.cvm_tm_id);
        while(this.cvm_nrQtde > 0){
            mq = new MaquinaPeriodo();
            mq.setMq_em_id(this.cvm_em_id + 8);
            mq.setMq_tm_id(this.cvm_tm_id);
            mq.setMq_nrIdade(0);
            mq.setMq_vlContabil(tm.getTm_vlInicial() * (1 + vvm.getVvm_pcVariacao()));
            mqDAO = new MaquinaPeriodoDAO();
            mqDAO.salvar(mq);
            this.cvm_nrQtde--;
        }

    }

/*    public static void main(String args[]) throws JogosDAOException{
        CompraVendaMaquinaDAO cvmDAO = new CompraVendaMaquinaDAO();
        CompraVendaMaquina cvm = cvmDAO.selectByEmpTipo(1990, 5, "C");
        cvm.comprar();
    }*/

}
