/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package entidades;

import dao.CustosFixoDAO;
import dao.EmpresaPeriodoDAO;
import dao.EstoquempDAO;
import dao.FolhaPagamentoDAO;
import dao.JogosDAOException;
import dao.MaquinaPeriodoDAO;
import dao.MateriaPrimaDAO;
import dao.ParamFixoDAO;
import dao.PeriodoDAO;

/**
 *'amortizacao'
'compramp'
'custosfixo'
'custovariavel'
'empresa'
'empresa_periodo'
 * 
 * @author Doglei
 */
public class CustosFixo implements java.io.Serializable {
    private int cf_id;
    private int cf_em_id;
    private double cf_vlTreinamento;
    private double cf_vlEstMP;
    private double cf_vlDeprecMaq;
    private double cf_vlDeprecPredio;


    /**
     *
     * @param cf_id
     * @param cf_em_id
     * @param cf_vlTreinamento
     * @param cf_vlEstMP
     * @param cf_vlDeprecMaq
     * @param cf_vlDeprecPredio
     */
    public CustosFixo(int cf_id, int cf_em_id, double cf_vlTreinamento,
            double cf_vlEstMP, double cf_vlDeprecMaq, double cf_vlDeprecPredio){
        this.cf_id = cf_id;
        this.cf_em_id = cf_em_id;
        this.cf_vlTreinamento = cf_vlTreinamento;
        this.cf_vlEstMP = cf_vlEstMP;
        this.cf_vlDeprecMaq = cf_vlDeprecMaq;
        this.cf_vlDeprecPredio = cf_vlDeprecPredio;
    }

    /**
     *
     * @return
     */
    public int getCf_em_id() {
        return cf_em_id;
    }

    /**
     *
     * @param cf_em_id
     */
    public void setCf_em_id(int cf_em_id) {
        this.cf_em_id = cf_em_id;
    }

    /**
     *
     * @return
     */
    public int getCf_id() {
        return cf_id;
    }

    /**
     *
     * @param cf_id
     */
    public void setCf_id(int cf_id) {
        this.cf_id = cf_id;
    }

    /**
     *
     * @return
     */
    public double getCf_vlDeprecMaq() {
        return cf_vlDeprecMaq;
    }

    /**
     *
     * @param cf_vlDeprecMaq
     */
    public void setCf_vlDeprecMaq(double cf_vlDeprecMaq) {
        this.cf_vlDeprecMaq = cf_vlDeprecMaq;
    }

    /**
     *
     * @return
     */
    public double getCf_vlDeprecPredio() {
        return cf_vlDeprecPredio;
    }

    /**
     *
     * @param cf_vlDeprecPredio
     */
    public void setCf_vlDeprecPredio(double cf_vlDeprecPredio) {
        this.cf_vlDeprecPredio = cf_vlDeprecPredio;
    }

    /**
     *
     * @return
     */
    public double getCf_vlEstMP() {
        return cf_vlEstMP;
    }

    /**
     *
     * @param cf_vlEstMP
     */
    public void setCf_vlEstMP(double cf_vlEstMP) {
        this.cf_vlEstMP = cf_vlEstMP;
    }

    /**
     *
     * @return
     */
    public double getCf_vlTreinamento() {
        return cf_vlTreinamento;
    }

    /**
     *
     * @param cf_vlTreinamento
     */
    public void setCf_vlTreinamento(double cf_vlTreinamento) {
        this.cf_vlTreinamento = cf_vlTreinamento;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double depreciacaoMaquinas() throws JogosDAOException{
        double depreciacaoMaquinas = 0.0;
        MaquinaPeriodoDAO mqDAO = new MaquinaPeriodoDAO();
        depreciacaoMaquinas = mqDAO.totalVlContabil(this.cf_em_id) * 0.025;
        return depreciacaoMaquinas;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double depreciacaoPredioRat() throws JogosDAOException{
        double depreciacaoPredioRat = 0.0;
        ParamFixoDAO pfxDAO = new ParamFixoDAO();
        EmpresaPeriodoDAO emDAO = new EmpresaPeriodoDAO();
        EmpresaPeriodo em = emDAO.empresaById(this.cf_em_id);
        PeriodoDAO peDAO = new PeriodoDAO();
        Periodo pe = peDAO.periodoById(em.getEm_pe_id());
        ParamFixo pf = pfxDAO.pfByTuId(pe.getPe_tu_id());
        depreciacaoPredioRat = pf.depreciacaoPredio() * 0.7;
        return depreciacaoPredioRat;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double totalCustosFixo() throws JogosDAOException{
        double totalCustosFixo = 0.0;
        FolhaPagamentoDAO fpDAO = new FolhaPagamentoDAO();
        FolhaPagamento fp = fpDAO.getFolhaObj(this.cf_em_id);
        totalCustosFixo = fp.totalSalario("Producao") + fp.rescisao() + fp.horaExtra() + fp.treinamento() + this.estocagemMP() + this.depreciacaoMaquinas() + this.depreciacaoPredioRat();
        return totalCustosFixo;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double estocagemMP() throws JogosDAOException{
        double estocagemMP = 0.0;
        double vlMPA = 0.0;
        double vlMPB = 0.0;
        EmpresaPeriodoDAO emDAO = new EmpresaPeriodoDAO();
        EmpresaPeriodo em = emDAO.empresaById(this.cf_em_id);
        MateriaPrimaDAO mpDAO = new MateriaPrimaDAO();
        MateriaPrima mp = mpDAO.mpByNo(em.getEm_pe_id(), "A");
        vlMPA = mp.getMp_vlPreco();
        mpDAO = new MateriaPrimaDAO();
        mp = mpDAO.mpByNo(em.getEm_pe_id(), "B");
        vlMPB = mp.getMp_vlPreco();
        EstoquempDAO esDAO = new EstoquempDAO();
        Estoquemp es = esDAO.getByEmPr(this.cf_em_id);
        estocagemMP = 0.05 * ((es.estoqueInicialMPA() * vlMPA) + (es.estoqueInicialMPB() * vlMPB));
        return estocagemMP;
    }


    /*public static void main(String args[]) throws JogosDAOException{
        CustosFixoDAO cfDAO = new CustosFixoDAO();
        CustosFixo cf = cfDAO.getByEmpresaPeriodo(9);
        System.out.println(cf.totalCustosFixo());
    }*/
 

}
