package entidades;

import dao.FluxocaixaDAO;
import dao.JogosDAOException;
import dao.RecebimentoDAO;
import dao.TipoCompraMpDAO;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author rafael
 */
public class Fluxocaixa {

    private int fx_id;
    private int fx_em_id;
    private double fx_vlAplicacao;
    private double fx_vlResgAplicacao;
    private double fx_vlDescDuplicatas;
    private double fx_pcJurosVdPz;
    private double fx_vlDiversos;
    private double fx_vlSaldoInicial;
    private double fx_vlSaldoFinal;
    private double fx_vlAtrasos;
    private double fx_vlInadimplencia;
    private double fx_vlRecebimentoAVista;
    private double fx_vlRecebimentoAPrazo;

    /**
     *
     * @param fx_id
     * @param fx_em_id
     * @param fx_vlAplicacao
     * @param fx_vlResgAplicacao
     * @param fx_vlDescDuplicatas
     * @param fx_pcJurosVdPz
     * @param fx_vlDiversos
     * @param fx_vlSaldoInicial
     * @param fx_vlSaldoFinal
     * @param fx_vlAtrasos
     * @param fx_vlInadimplencia
     * @param fx_vlRecebimentoAVista
     * @param fx_vlRecebimentoAPrazo
     */
    public Fluxocaixa(int fx_id, int fx_em_id, double fx_vlAplicacao, double fx_vlResgAplicacao, double fx_vlDescDuplicatas, double fx_pcJurosVdPz, double fx_vlDiversos, double fx_vlSaldoInicial, double fx_vlSaldoFinal, double fx_vlAtrasos, double fx_vlInadimplencia, double fx_vlRecebimentoAVista, double fx_vlRecebimentoAPrazo) {
        this.fx_id = fx_id;
        this.fx_em_id = fx_em_id;
        this.fx_vlAplicacao = fx_vlAplicacao;
        this.fx_vlResgAplicacao = fx_vlResgAplicacao;
        this.fx_vlDescDuplicatas = fx_vlDescDuplicatas;
        this.fx_pcJurosVdPz = fx_pcJurosVdPz;
        this.fx_vlDiversos = fx_vlDiversos;
        this.fx_vlSaldoInicial = fx_vlSaldoInicial;
        this.fx_vlSaldoFinal = fx_vlSaldoFinal;
        this.fx_vlAtrasos = fx_vlAtrasos;
        this.fx_vlInadimplencia = fx_vlInadimplencia;
        this.fx_vlRecebimentoAVista = fx_vlRecebimentoAVista;
        this.fx_vlRecebimentoAPrazo = fx_vlRecebimentoAPrazo;
    }

    /**
     *
     * @param obj
     * @throws JogosDAOException
     */
    public Fluxocaixa(Fluxocaixa obj) throws JogosDAOException {
        this.fx_id = obj.getFx_id();
        this.fx_em_id = obj.getFx_em_id();
        this.fx_vlAplicacao = obj.getFx_vlAplicacao();
        this.fx_vlResgAplicacao = obj.getFx_vlResgAplicacao();
        this.fx_vlDescDuplicatas = obj.getFx_vlDescDuplicatas();
        this.fx_pcJurosVdPz = obj.getFx_pcJurosVdPz();
        this.fx_vlDiversos = obj.getFx_vlDiversos();
        this.fx_vlSaldoInicial = obj.getFx_vlSaldoInicial();
        this.fx_vlSaldoFinal = obj.getFx_vlSaldoFinal();
        this.fx_vlAtrasos = obj.getFx_vlAtrasos();
        this.fx_vlInadimplencia = obj.getFx_vlInadimplencia();
    }

    /**
     *
     * @return
     */
    public int getFx_em_id() {
        return fx_em_id;
    }

    /**
     *
     * @param fx_em_id
     */
    public void setFx_em_id(int fx_em_id) {
        this.fx_em_id = fx_em_id;
    }

    /**
     *
     * @return
     */
    public int getFx_id() {
        return fx_id;
    }

    /**
     *
     * @param fx_id
     */
    public void setFx_id(int fx_id) {
        this.fx_id = fx_id;
    }

    /**
     *
     * @return
     */
    public double getFx_pcJurosVdPz() {
        return fx_pcJurosVdPz;
    }

    /**
     *
     * @param fx_pcJurosVdPz
     */
    public void setFx_pcJurosVdPz(double fx_pcJurosVdPz) {
        this.fx_pcJurosVdPz = fx_pcJurosVdPz;
    }

    /**
     *
     * @return
     */
    public double getFx_vlAplicacao() {
        return fx_vlAplicacao;
    }

    /**
     *
     * @param fx_vlAplicacao
     */
    public void setFx_vlAplicacao(double fx_vlAplicacao) {
        this.fx_vlAplicacao = fx_vlAplicacao;
    }

    /**
     *
     * @return
     */
    public double getFx_vlAtrasos() {
        return fx_vlAtrasos;
    }

    /**
     *
     * @param fx_vlAtrasos
     */
    public void setFx_vlAtrasos(double fx_vlAtrasos) {
        this.fx_vlAtrasos = fx_vlAtrasos;
    }

    /**
     *
     * @return
     */
    public double getFx_vlDescDuplicatas() {
        return fx_vlDescDuplicatas;
    }

    /**
     *
     * @param fx_vlDescDuplicatas
     */
    public void setFx_vlDescDuplicatas(double fx_vlDescDuplicatas) {
        this.fx_vlDescDuplicatas = fx_vlDescDuplicatas;
    }

    /**
     *
     * @return
     */
    public double getFx_vlDiversos() {
        return fx_vlDiversos;
    }

    /**
     *
     * @param fx_vlDiversos
     */
    public void setFx_vlDiversos(double fx_vlDiversos) {
        this.fx_vlDiversos = fx_vlDiversos;
    }

    /**
     *
     * @return
     */
    public double getFx_vlResgAplicacao() {
        return fx_vlResgAplicacao;
    }

    /**
     *
     * @param fx_vlResgAplicacao
     */
    public void setFx_vlResgAplicacao(double fx_vlResgAplicacao) {
        this.fx_vlResgAplicacao = fx_vlResgAplicacao;
    }

    /**
     *
     * @return
     */
    public double getFx_vlSaldoFinal() {
        return fx_vlSaldoFinal;
    }

    /**
     *
     * @param fx_vlSaldoFinal
     */
    public void setFx_vlSaldoFinal(double fx_vlSaldoFinal) {
        this.fx_vlSaldoFinal = fx_vlSaldoFinal;
    }

    /**
     *
     * @return
     */
    public double getFx_vlSaldoInicial() {
        return fx_vlSaldoInicial;
    }

    /**
     *
     * @param fx_vlSaldoInicial
     */
    public void setFx_vlSaldoInicial(double fx_vlSaldoInicial) {
        this.fx_vlSaldoInicial = fx_vlSaldoInicial;
    }

    /**
     *
     * @return
     */
    public double getFx_vlInadimplencia() {
        return fx_vlInadimplencia;
    }

    /**
     *
     * @param fx_vlInadimplencia
     */
    public void setFx_vlInadimplencia(double fx_vlInadimplencia) {
        this.fx_vlInadimplencia = fx_vlInadimplencia;
    }

    /**
     *
     * @return
     */
    public double getFx_vlRecebimentoAPrazo() {
        return fx_vlRecebimentoAPrazo;
    }

    /**
     *
     * @param fx_vlRecebimentoAPrazo
     */
    public void setFx_vlRecebimentoAPrazo(double fx_vlRecebimentoAPrazo) {
        this.fx_vlRecebimentoAPrazo = fx_vlRecebimentoAPrazo;
    }

    /**
     *
     * @return
     */
    public double getFx_vlRecebimentoAVista() {
        return fx_vlRecebimentoAVista;
    }

    /**
     *
     * @param fx_vlRecebimentoAVista
     */
    public void setFx_vlRecebimentoAVista(double fx_vlRecebimentoAVista) {
        this.fx_vlRecebimentoAVista = fx_vlRecebimentoAVista;
    }
    
    /**
     *
     * @throws JogosDAOException
     */
    public void calcRecebimentos() throws JogosDAOException{
        TipoCompraMpDAO tcmDAO = new TipoCompraMpDAO();
        RecebimentoDAO rbDAO;
        List lTcm = tcmDAO.getByTipoLista("V");
        Iterator i = lTcm.iterator();
        while(i.hasNext()){
            TipoCompraMp tcm = (TipoCompraMp)i.next();
            rbDAO = new RecebimentoDAO();
            if(tcm.getTcm_nome().compareTo("Prazo 0") == 0){
                this.fx_vlRecebimentoAVista = this.fx_vlRecebimentoAVista + rbDAO.somaRecebimento(this.fx_em_id, tcm.getTcm_id());
            }
            else{
                this.fx_vlRecebimentoAPrazo = this.fx_vlRecebimentoAPrazo + rbDAO.somaRecebimento(this.fx_em_id, tcm.getTcm_id());
            }
        }        
    }

/*    public static void main (String args[]) throws JogosDAOException{
        FluxocaixaDAO fxDAO = new FluxocaixaDAO();
        Fluxocaixa fx = fxDAO.getByEmPr(1774);
        fx.setFx_vlDescDuplicatas(1000.0);
        fx.setFx_vlAplicacao(1000.0);
        fx.setFx_vlInadimplencia(1000.0);
        fx.setFx_vlDiversos(1000.0);
        fxDAO = new FluxocaixaDAO();
        fxDAO.atualizar(fx);
        System.out.println(fx.getFx_vlRecebimentoAPrazo());

    }*/

}
