/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package entidades;

import dao.FolhaPagamentoDAO;
import dao.JogosDAOException;
import dao.PessoalDAO;
import dao.ProdutividadeDAO;
import java.sql.SQLException;
/**
 *
 * @author rafael
 */
public class FolhaPagamento {
    private int fp_id;
    private int fp_em_id;
    private double fp_pcTreinamento;
    private int fp_nrAdmitidos;
    private int fp_nrDemitidos;
    private Double fp_pcPartLucro;
    private Double fp_vlSalarioBase;

    /**
     *
     * @param fp_id
     * @param fp_em_id
     * @param fp_pcTreinamento
     * @param fp_pcPartLucro
     * @param fp_vlSalarioBase
     */
    public FolhaPagamento(int fp_id, int fp_em_id, double fp_pcTreinamento, Double fp_pcPartLucro, Double fp_vlSalarioBase) {
        this.fp_id = fp_id;
        this.fp_em_id = fp_em_id;
        this.fp_pcTreinamento = fp_pcTreinamento;
        this.fp_pcPartLucro = fp_pcPartLucro;
        this.fp_vlSalarioBase = fp_vlSalarioBase;
    }
    /**
     *
     */
    public FolhaPagamento() {
        this.fp_id = 0;
        this.fp_em_id = 0;
        this.fp_pcTreinamento = 0;
        this.fp_nrAdmitidos = 0;
        this.fp_nrDemitidos = 0;
        this.fp_pcPartLucro = 0.0;
        this.fp_vlSalarioBase = 0.0;
    }
    /**
     *
     * @param obj
     */
    public FolhaPagamento(FolhaPagamento obj){
        this.fp_id = obj.getFp_id();
        this.fp_em_id = obj.getFp_em_id();
        this.fp_pcPartLucro = obj.getFp_pcPartLucro();
        this.fp_vlSalarioBase = obj.getFp_vlSalarioBase();
        this.fp_nrAdmitidos = obj.getFp_nrAdmitidos();
        this.fp_nrDemitidos = obj.getFp_nrDemitidos();
    }

    /**
     *
     * @return
     */
    public int getFp_nrAdmitidos() {
        return fp_nrAdmitidos;
    }

    /**
     *
     * @param fp_nrAdmitidos
     */
    public void setFp_nrAdmitidos(int fp_nrAdmitidos) {
        this.fp_nrAdmitidos = fp_nrAdmitidos;
    }

    /**
     *
     * @return
     */
    public int getFp_nrDemitidos() {
        return fp_nrDemitidos;
    }

    /**
     *
     * @param fp_nrDemitidos
     */
    public void setFp_nrDemitidos(int fp_nrDemitidos) {
        this.fp_nrDemitidos = fp_nrDemitidos;
    }


    /**
     *
     * @return
     */
    public Double getFp_vlSalarioBase() {
        return fp_vlSalarioBase;
    }

    /**
     *
     * @param fp_vlSalarioBase
     */
    public void setFp_vlSalarioBase(Double fp_vlSalarioBase) {
        this.fp_vlSalarioBase = fp_vlSalarioBase;
    }

    /**
     *
     * @return
     */
    public int getFp_em_id() {
        return fp_em_id;
    }

    /**
     *
     * @param fp_em_id
     */
    public void setFp_em_id(int fp_em_id) {
        this.fp_em_id = fp_em_id;
    }

    /**
     *
     * @return
     */
    public Double getFp_pcTreinamento() {
        return fp_pcTreinamento;
    }

    /**
     *
     * @param fp_pcTreinamento
     */
    public void setFp_pcTreinamento(Double fp_pcTreinamento) {
        this.fp_pcTreinamento = fp_pcTreinamento;
    }

    /**
     *
     * @return
     */
    public int getFp_id() {
        return fp_id;
    }

    /**
     *
     * @param fp_id
     */
    public void setFp_id(int fp_id) {
        this.fp_id = fp_id;
    }

    /**
     *
     * @return
     */
    public Double getFp_pcPartLucro() {
        return fp_pcPartLucro;
    }

    /**
     *
     * @param fp_pcPartLucro
     */
    public void setFp_pcPartLucro(Double fp_pcPartLucro) {
        this.fp_pcPartLucro = fp_pcPartLucro;
    }

    /**
     *
     * @param noSetor
     * @return
     * @throws JogosDAOException
     */
    public double totalSalario(String noSetor) throws JogosDAOException{
        double vlTotalSalario = 0.0;
        int qtEmpregados = 0;
        PessoalDAO pesDAO = new PessoalDAO();
        Pessoal pes = pesDAO.pessoalBySetor(this.fp_em_id, noSetor);
        if (pes.getPs_noSetor().compareTo("Producao".trim()) == 0){
            qtEmpregados = pes.getPs_qtEmpregados() + this.fp_nrAdmitidos;
        }
        else{
            qtEmpregados = pes.getPs_qtEmpregados();
        }
        vlTotalSalario = qtEmpregados * this.fp_vlSalarioBase * pes.getPs_qtSalario();
        return vlTotalSalario;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double rescisao() throws JogosDAOException{
        PessoalDAO pesDAO = new PessoalDAO();
        Pessoal pes = pesDAO.pessoalBySetor(this.fp_em_id, "Producao");
        double rescisao = this.fp_vlSalarioBase * pes.getPs_qtSalario() * this.fp_nrDemitidos * 0.6;
        return rescisao;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double participacao() throws JogosDAOException{
        double vlParticipacao = 0.0;
        vlParticipacao = this.totalSalario("Producao") * this.fp_pcPartLucro;
        return vlParticipacao;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double treinamento() throws JogosDAOException{
        double vlTreinamento = 0.0;
        vlTreinamento = this.totalSalario("Producao") * this.fp_pcTreinamento;
        return vlTreinamento;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double horaExtra() throws JogosDAOException{
        double vlHoraExtra = 0.0;
        ProdutividadeDAO prDAO = new ProdutividadeDAO();
        Produtividade pr = prDAO.getById(this.fp_em_id);
        if (pr.getPd_pcHoraExtra() > 1){
            vlHoraExtra = this.totalSalario("Producao")* pr.getPd_pcHoraExtra() * 0.5;
        }
        return vlHoraExtra;
    }

    /**
     *
     * @return
     * @throws JogosDAOException
     */
    public double totalFolha() throws JogosDAOException{
        double vlTotalFolha = 0.0;
        vlTotalFolha = this.totalSalario("Producao") + this.totalSalario("Adm") + this.totalSalario("Vendas");
        return vlTotalFolha;
    }

/*    public static void main(String args[]) throws JogosDAOException{
        FolhaPagamentoDAO fpDAO = new FolhaPagamentoDAO();
        FolhaPagamento fp = fpDAO.getFolhaObj(105);
        System.out.println(fp.horaExtra());

    }*/

}
